/* game.c generated by valac 0.56.17, the Vala compiler
 * generated from game.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2009 Lubomir Rintel <lkundrak@v3.sk>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>
#include <math.h>
#include <float.h>
#include <string.h>

#define NCOLORS 7
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BLOCK (block_get_type ())
#define BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BLOCK, Block))
#define BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BLOCK, BlockClass))
#define IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BLOCK))
#define IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BLOCK))
#define BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BLOCK, BlockClass))

typedef struct _Block Block;
typedef struct _BlockClass BlockClass;
typedef struct _BlockPrivate BlockPrivate;
enum  {
	BLOCK_0_PROPERTY,
	BLOCK_NUM_PROPERTIES
};
static GParamSpec* block_properties[BLOCK_NUM_PROPERTIES];

#define TYPE_SHAPE (shape_get_type ())
#define SHAPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SHAPE, Shape))
#define SHAPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SHAPE, ShapeClass))
#define IS_SHAPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SHAPE))
#define IS_SHAPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SHAPE))
#define SHAPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SHAPE, ShapeClass))

typedef struct _Shape Shape;
typedef struct _ShapeClass ShapeClass;
typedef struct _ShapePrivate ShapePrivate;
enum  {
	SHAPE_0_PROPERTY,
	SHAPE_NUM_PROPERTIES
};
static GParamSpec* shape_properties[SHAPE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
enum  {
	GAME_0_PROPERTY,
	GAME_WIDTH_PROPERTY,
	GAME_HEIGHT_PROPERTY,
	GAME_LEVEL_PROPERTY,
	GAME_PAUSED_PROPERTY,
	GAME_SHADOW_Y_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
enum  {
	GAME_STARTED_SIGNAL,
	GAME_SHAPE_ADDED_SIGNAL,
	GAME_SHAPE_MOVED_SIGNAL,
	GAME_SHAPE_DROPPED_SIGNAL,
	GAME_SHAPE_ROTATED_SIGNAL,
	GAME_SHAPE_LANDED_SIGNAL,
	GAME_PAUSE_CHANGED_SIGNAL,
	GAME_COMPLETE_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};

struct _Block {
	GObject parent_instance;
	BlockPrivate * priv;
	gint x;
	gint y;
	gint color;
};

struct _BlockClass {
	GObjectClass parent_class;
};

struct _Shape {
	GObject parent_instance;
	ShapePrivate * priv;
	gint x;
	gint y;
	gint rotation;
	gint type;
	GList* blocks;
};

struct _ShapeClass {
	GObjectClass parent_class;
};

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
	Shape* shape;
	Shape* next_shape;
	Block** blocks;
	gint blocks_length1;
	gint blocks_length2;
	gint n_lines_destroyed;
	gint score;
	gboolean game_over;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	gint starting_level;
	gboolean pick_difficult_blocks;
	gint fast_move_direction;
	guint fast_move_timeout;
	gboolean fast_forward;
	guint drop_timeout;
	gboolean has_started;
	gboolean _paused;
};

static gpointer block_parent_class = NULL;
static gpointer shape_parent_class = NULL;
static gint Game_private_offset;
static gpointer game_parent_class = NULL;

VALA_EXTERN GType block_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Block, g_object_unref)
VALA_EXTERN Block* block_copy (Block* self);
VALA_EXTERN Block* block_new (void);
VALA_EXTERN Block* block_construct (GType object_type);
static void block_finalize (GObject * obj);
static GType block_get_type_once (void);
VALA_EXTERN GType shape_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Shape, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN Shape* shape_copy (Shape* self);
VALA_EXTERN Shape* shape_new (void);
VALA_EXTERN Shape* shape_construct (GType object_type);
static void shape_finalize (GObject * obj);
static GType shape_get_type_once (void);
VALA_EXTERN GType game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
VALA_EXTERN Game* game_new (gint lines,
                gint columns,
                gint starting_level,
                gint filled_lines,
                gint fill_prob,
                gboolean pick_difficult_blocks);
VALA_EXTERN Game* game_construct (GType object_type,
                      gint lines,
                      gint columns,
                      gint starting_level,
                      gint filled_lines,
                      gint fill_prob,
                      gboolean pick_difficult_blocks);
VALA_EXTERN gint game_get_height (Game* self);
VALA_EXTERN gint game_get_width (Game* self);
static Shape* game_pick_random_shape (Game* self);
VALA_EXTERN Game* game_copy (Game* self);
VALA_EXTERN void game_start (Game* self);
static void game_make_next_shape (Game* self);
static void game_add_shape (Game* self);
static void game_setup_drop_timer (Game* self);
VALA_EXTERN gboolean game_move_left (Game* self);
static gboolean game_move_direction (Game* self,
                              gint direction);
VALA_EXTERN gboolean game_move_right (Game* self);
VALA_EXTERN gboolean game_stop_moving (Game* self);
VALA_EXTERN gboolean game_rotate_left (Game* self);
static gboolean game_move_shape (Game* self,
                          gint x_step,
                          gint y_step,
                          gint r_step);
VALA_EXTERN gboolean game_rotate_right (Game* self);
VALA_EXTERN void game_set_fast_forward (Game* self,
                            gboolean enable);
VALA_EXTERN void game_drop (Game* self);
static gboolean game_fall_timeout_cb (Game* self);
VALA_EXTERN void game_stop (Game* self);
static gboolean game_move (Game* self);
static gboolean game_setup_fast_move_cb (Game* self);
static gboolean _game_setup_fast_move_cb_gsource_func (gpointer self);
static gboolean _game_move_gsource_func (gpointer self);
VALA_EXTERN gint game_get_level (Game* self);
VALA_EXTERN gboolean game_get_paused (Game* self);
static gboolean _game_fall_timeout_cb_gsource_func (gpointer self);
static void game_land_shape (Game* self);
static Shape* game_pick_difficult_shapes (Game* self);
static Shape* game_make_shape (Game* self,
                        gint type,
                        gint rotation);
static void game_rotate_shape (Game* self,
                        gint r_step);
VALA_EXTERN void game_set_paused (Game* self,
                      gboolean value);
VALA_EXTERN gint game_get_shadow_y (Game* self);
static void g_cclosure_user_marshal_VOID__POINTER_INT_POINTER (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data);
static void game_finalize (GObject * obj);
static GType game_get_type_once (void);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

const gint block_table[448] = {0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0};

Block*
block_copy (Block* self)
{
	Block* b = NULL;
	Block* _tmp0_;
	Block* result;
#line 181 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 183 "../src/game.vala"
	_tmp0_ = block_new ();
#line 183 "../src/game.vala"
	b = _tmp0_;
#line 184 "../src/game.vala"
	b->x = self->x;
#line 185 "../src/game.vala"
	b->y = self->y;
#line 186 "../src/game.vala"
	b->color = self->color;
#line 187 "../src/game.vala"
	result = b;
#line 187 "../src/game.vala"
	return result;
#line 285 "game.c"
}

Block*
block_construct (GType object_type)
{
	Block * self = NULL;
#line 172 "../src/game.vala"
	self = (Block*) g_object_new (object_type, NULL);
#line 172 "../src/game.vala"
	return self;
#line 296 "game.c"
}

Block*
block_new (void)
{
#line 172 "../src/game.vala"
	return block_construct (TYPE_BLOCK);
#line 304 "game.c"
}

static void
block_class_init (BlockClass * klass,
                  gpointer klass_data)
{
#line 172 "../src/game.vala"
	block_parent_class = g_type_class_peek_parent (klass);
#line 172 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = block_finalize;
#line 315 "game.c"
}

static void
block_instance_init (Block * self,
                     gpointer klass)
{
}

static void
block_finalize (GObject * obj)
{
	Block * self;
#line 172 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BLOCK, Block);
#line 172 "../src/game.vala"
	G_OBJECT_CLASS (block_parent_class)->finalize (obj);
#line 332 "game.c"
}

static GType
block_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BlockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) block_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Block), 0, (GInstanceInitFunc) block_instance_init, NULL };
	GType block_type_id;
	block_type_id = g_type_register_static (G_TYPE_OBJECT, "Block", &g_define_type_info, 0);
	return block_type_id;
}

GType
block_get_type (void)
{
	static volatile gsize block_type_id__once = 0;
	if (g_once_init_enter (&block_type_id__once)) {
		GType block_type_id;
		block_type_id = block_get_type_once ();
		g_once_init_leave (&block_type_id__once, block_type_id);
	}
	return block_type_id__once;
}

static void
_g_object_unref0_ (gpointer var)
{
#line 204 "../src/game.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 361 "game.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 204 "../src/game.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 369 "game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 213 "../src/game.vala"
	return self ? g_object_ref (self) : NULL;
#line 377 "game.c"
}

Shape*
shape_copy (Shape* self)
{
	Shape* s = NULL;
	Shape* _tmp0_;
	Shape* _tmp1_;
	Shape* _tmp2_;
	Shape* _tmp3_;
	Shape* _tmp4_;
	GList* _tmp5_;
	Shape* result;
#line 206 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "../src/game.vala"
	_tmp0_ = shape_new ();
#line 208 "../src/game.vala"
	s = _tmp0_;
#line 209 "../src/game.vala"
	_tmp1_ = s;
#line 209 "../src/game.vala"
	_tmp1_->x = self->x;
#line 210 "../src/game.vala"
	_tmp2_ = s;
#line 210 "../src/game.vala"
	_tmp2_->y = self->y;
#line 211 "../src/game.vala"
	_tmp3_ = s;
#line 211 "../src/game.vala"
	_tmp3_->rotation = self->rotation;
#line 212 "../src/game.vala"
	_tmp4_ = s;
#line 212 "../src/game.vala"
	_tmp4_->type = self->type;
#line 213 "../src/game.vala"
	_tmp5_ = self->blocks;
#line 415 "game.c"
	{
		GList* b_collection = NULL;
		GList* b_it = NULL;
#line 213 "../src/game.vala"
		b_collection = _tmp5_;
#line 213 "../src/game.vala"
		for (b_it = b_collection; b_it != NULL; b_it = b_it->next) {
#line 423 "game.c"
			Block* _tmp6_;
			Block* b = NULL;
#line 213 "../src/game.vala"
			_tmp6_ = _g_object_ref0 ((Block*) b_it->data);
#line 213 "../src/game.vala"
			b = _tmp6_;
#line 430 "game.c"
			{
				Shape* _tmp7_;
				Block* _tmp8_;
				Block* _tmp9_;
#line 214 "../src/game.vala"
				_tmp7_ = s;
#line 214 "../src/game.vala"
				_tmp8_ = b;
#line 214 "../src/game.vala"
				_tmp9_ = block_copy (_tmp8_);
#line 214 "../src/game.vala"
				_tmp7_->blocks = g_list_append (_tmp7_->blocks, _tmp9_);
#line 213 "../src/game.vala"
				_g_object_unref0 (b);
#line 445 "game.c"
			}
		}
	}
#line 215 "../src/game.vala"
	result = s;
#line 215 "../src/game.vala"
	return result;
#line 453 "game.c"
}

Shape*
shape_construct (GType object_type)
{
	Shape * self = NULL;
#line 191 "../src/game.vala"
	self = (Shape*) g_object_new (object_type, NULL);
#line 191 "../src/game.vala"
	return self;
#line 464 "game.c"
}

Shape*
shape_new (void)
{
#line 191 "../src/game.vala"
	return shape_construct (TYPE_SHAPE);
#line 472 "game.c"
}

static void
shape_class_init (ShapeClass * klass,
                  gpointer klass_data)
{
#line 191 "../src/game.vala"
	shape_parent_class = g_type_class_peek_parent (klass);
#line 191 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = shape_finalize;
#line 483 "game.c"
}

static void
shape_instance_init (Shape * self,
                     gpointer klass)
{
#line 204 "../src/game.vala"
	self->blocks = NULL;
#line 492 "game.c"
}

static void
shape_finalize (GObject * obj)
{
	Shape * self;
#line 191 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SHAPE, Shape);
#line 204 "../src/game.vala"
	(self->blocks == NULL) ? NULL : (self->blocks = (_g_list_free__g_object_unref0_ (self->blocks), NULL));
#line 191 "../src/game.vala"
	G_OBJECT_CLASS (shape_parent_class)->finalize (obj);
#line 505 "game.c"
}

static GType
shape_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ShapeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) shape_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Shape), 0, (GInstanceInitFunc) shape_instance_init, NULL };
	GType shape_type_id;
	shape_type_id = g_type_register_static (G_TYPE_OBJECT, "Shape", &g_define_type_info, 0);
	return shape_type_id;
}

GType
shape_get_type (void)
{
	static volatile gsize shape_type_id__once = 0;
	if (g_once_init_enter (&shape_type_id__once)) {
		GType shape_type_id;
		shape_type_id = shape_get_type_once ();
		g_once_init_leave (&shape_type_id__once, shape_type_id);
	}
	return shape_type_id__once;
}

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

Game*
game_construct (GType object_type,
                gint lines,
                gint columns,
                gint starting_level,
                gint filled_lines,
                gint fill_prob,
                gboolean pick_difficult_blocks)
{
	Game * self = NULL;
	Block** _tmp0_;
#line 305 "../src/game.vala"
	self = (Game*) g_object_new (object_type, NULL);
#line 307 "../src/game.vala"
	self->priv->starting_level = starting_level;
#line 308 "../src/game.vala"
	self->priv->pick_difficult_blocks = pick_difficult_blocks;
#line 310 "../src/game.vala"
	_tmp0_ = g_new0 (Block*, (columns * lines) + 1);
#line 310 "../src/game.vala"
	self->blocks = (_vala_array_free (self->blocks, self->blocks_length1 * self->blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 310 "../src/game.vala"
	self->blocks = _tmp0_;
#line 310 "../src/game.vala"
	self->blocks_length1 = columns;
#line 310 "../src/game.vala"
	self->blocks_length2 = lines;
#line 562 "game.c"
	{
		gint y = 0;
#line 312 "../src/game.vala"
		y = 0;
#line 567 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 312 "../src/game.vala"
			_tmp1_ = TRUE;
#line 312 "../src/game.vala"
			while (TRUE) {
#line 574 "game.c"
				gint _tmp3_;
				gint _tmp4_;
				gint32 blank = 0;
				gint _tmp5_;
				gint _tmp6_;
#line 312 "../src/game.vala"
				if (!_tmp1_) {
#line 582 "game.c"
					gint _tmp2_;
#line 312 "../src/game.vala"
					_tmp2_ = y;
#line 312 "../src/game.vala"
					y = _tmp2_ + 1;
#line 588 "game.c"
				}
#line 312 "../src/game.vala"
				_tmp1_ = FALSE;
#line 312 "../src/game.vala"
				_tmp3_ = game_get_height (self);
#line 312 "../src/game.vala"
				_tmp4_ = _tmp3_;
#line 312 "../src/game.vala"
				if (!(y < _tmp4_)) {
#line 312 "../src/game.vala"
					break;
#line 600 "game.c"
				}
#line 315 "../src/game.vala"
				_tmp5_ = game_get_width (self);
#line 315 "../src/game.vala"
				_tmp6_ = _tmp5_;
#line 315 "../src/game.vala"
				blank = g_random_int_range ((gint32) 0, (gint32) _tmp6_);
#line 608 "game.c"
				{
					gint x = 0;
#line 317 "../src/game.vala"
					x = 0;
#line 613 "game.c"
					{
						gboolean _tmp7_ = FALSE;
#line 317 "../src/game.vala"
						_tmp7_ = TRUE;
#line 317 "../src/game.vala"
						while (TRUE) {
#line 620 "game.c"
							gint _tmp9_;
							gint _tmp10_;
							gboolean _tmp11_ = FALSE;
							gboolean _tmp12_ = FALSE;
							gint _tmp13_;
							gint _tmp14_;
#line 317 "../src/game.vala"
							if (!_tmp7_) {
#line 629 "game.c"
								gint _tmp8_;
#line 317 "../src/game.vala"
								_tmp8_ = x;
#line 317 "../src/game.vala"
								x = _tmp8_ + 1;
#line 635 "game.c"
							}
#line 317 "../src/game.vala"
							_tmp7_ = FALSE;
#line 317 "../src/game.vala"
							_tmp9_ = game_get_width (self);
#line 317 "../src/game.vala"
							_tmp10_ = _tmp9_;
#line 317 "../src/game.vala"
							if (!(x < _tmp10_)) {
#line 317 "../src/game.vala"
								break;
#line 647 "game.c"
							}
#line 319 "../src/game.vala"
							_tmp13_ = game_get_height (self);
#line 319 "../src/game.vala"
							_tmp14_ = _tmp13_;
#line 319 "../src/game.vala"
							if (y >= (_tmp14_ - filled_lines)) {
#line 319 "../src/game.vala"
								_tmp12_ = x != ((gint) blank);
#line 657 "game.c"
							} else {
#line 319 "../src/game.vala"
								_tmp12_ = FALSE;
#line 661 "game.c"
							}
#line 319 "../src/game.vala"
							if (_tmp12_) {
#line 319 "../src/game.vala"
								_tmp11_ = g_random_int_range ((gint32) 0, (gint32) 10) < ((gint32) fill_prob);
#line 667 "game.c"
							} else {
#line 319 "../src/game.vala"
								_tmp11_ = FALSE;
#line 671 "game.c"
							}
#line 319 "../src/game.vala"
							if (_tmp11_) {
#line 675 "game.c"
								Block** _tmp15_;
								gint _tmp15__length1;
								gint _tmp15__length2;
								Block* _tmp16_;
								Block** _tmp17_;
								gint _tmp17__length1;
								gint _tmp17__length2;
								Block* _tmp18_;
								Block** _tmp19_;
								gint _tmp19__length1;
								gint _tmp19__length2;
								Block* _tmp20_;
								Block** _tmp21_;
								gint _tmp21__length1;
								gint _tmp21__length2;
								Block* _tmp22_;
#line 321 "../src/game.vala"
								_tmp15_ = self->blocks;
#line 321 "../src/game.vala"
								_tmp15__length1 = self->blocks_length1;
#line 321 "../src/game.vala"
								_tmp15__length2 = self->blocks_length2;
#line 321 "../src/game.vala"
								_tmp16_ = block_new ();
#line 321 "../src/game.vala"
								_g_object_unref0 (_tmp15_[(x * _tmp15__length2) + y]);
#line 321 "../src/game.vala"
								_tmp15_[(x * _tmp15__length2) + y] = _tmp16_;
#line 322 "../src/game.vala"
								_tmp17_ = self->blocks;
#line 322 "../src/game.vala"
								_tmp17__length1 = self->blocks_length1;
#line 322 "../src/game.vala"
								_tmp17__length2 = self->blocks_length2;
#line 322 "../src/game.vala"
								_tmp18_ = _tmp17_[(x * _tmp17__length2) + y];
#line 322 "../src/game.vala"
								_tmp18_->x = x;
#line 323 "../src/game.vala"
								_tmp19_ = self->blocks;
#line 323 "../src/game.vala"
								_tmp19__length1 = self->blocks_length1;
#line 323 "../src/game.vala"
								_tmp19__length2 = self->blocks_length2;
#line 323 "../src/game.vala"
								_tmp20_ = _tmp19_[(x * _tmp19__length2) + y];
#line 323 "../src/game.vala"
								_tmp20_->y = y;
#line 324 "../src/game.vala"
								_tmp21_ = self->blocks;
#line 324 "../src/game.vala"
								_tmp21__length1 = self->blocks_length1;
#line 324 "../src/game.vala"
								_tmp21__length2 = self->blocks_length2;
#line 324 "../src/game.vala"
								_tmp22_ = _tmp21_[(x * _tmp21__length2) + y];
#line 324 "../src/game.vala"
								_tmp22_->color = (gint) g_random_int_range ((gint32) 0, (gint32) NCOLORS);
#line 734 "game.c"
							} else {
								Block** _tmp23_;
								gint _tmp23__length1;
								gint _tmp23__length2;
#line 327 "../src/game.vala"
								_tmp23_ = self->blocks;
#line 327 "../src/game.vala"
								_tmp23__length1 = self->blocks_length1;
#line 327 "../src/game.vala"
								_tmp23__length2 = self->blocks_length2;
#line 327 "../src/game.vala"
								_g_object_unref0 (_tmp23_[(x * _tmp23__length2) + y]);
#line 327 "../src/game.vala"
								_tmp23_[(x * _tmp23__length2) + y] = NULL;
#line 749 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 331 "../src/game.vala"
	if (!pick_difficult_blocks) {
#line 759 "game.c"
		Shape* _tmp24_;
#line 332 "../src/game.vala"
		_tmp24_ = game_pick_random_shape (self);
#line 332 "../src/game.vala"
		_g_object_unref0 (self->next_shape);
#line 332 "../src/game.vala"
		self->next_shape = _tmp24_;
#line 767 "game.c"
	}
#line 305 "../src/game.vala"
	return self;
#line 771 "game.c"
}

Game*
game_new (gint lines,
          gint columns,
          gint starting_level,
          gint filled_lines,
          gint fill_prob,
          gboolean pick_difficult_blocks)
{
#line 305 "../src/game.vala"
	return game_construct (TYPE_GAME, lines, columns, starting_level, filled_lines, fill_prob, pick_difficult_blocks);
#line 784 "game.c"
}

Game*
game_copy (Game* self)
{
	Game* g = NULL;
	Game* _tmp0_;
	Shape* _tmp1_;
	Shape* _tmp5_;
	Game* _tmp24_;
	Game* _tmp25_;
	Game* _tmp26_;
	Game* _tmp27_;
	Game* _tmp28_;
	Game* _tmp29_;
	Game* _tmp30_;
	Game* _tmp31_;
	Game* _tmp32_;
	Game* result;
#line 335 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 337 "../src/game.vala"
	_tmp0_ = game_new (20, 10, 1, 0, 5, FALSE);
#line 337 "../src/game.vala"
	g = _tmp0_;
#line 338 "../src/game.vala"
	_tmp1_ = self->shape;
#line 338 "../src/game.vala"
	if (_tmp1_ != NULL) {
#line 814 "game.c"
		Game* _tmp2_;
		Shape* _tmp3_;
		Shape* _tmp4_;
#line 339 "../src/game.vala"
		_tmp2_ = g;
#line 339 "../src/game.vala"
		_tmp3_ = self->shape;
#line 339 "../src/game.vala"
		_tmp4_ = shape_copy (_tmp3_);
#line 339 "../src/game.vala"
		_g_object_unref0 (_tmp2_->shape);
#line 339 "../src/game.vala"
		_tmp2_->shape = _tmp4_;
#line 828 "game.c"
	}
#line 340 "../src/game.vala"
	_tmp5_ = self->next_shape;
#line 340 "../src/game.vala"
	if (_tmp5_ != NULL) {
#line 834 "game.c"
		Game* _tmp6_;
		Shape* _tmp7_;
		Shape* _tmp8_;
#line 341 "../src/game.vala"
		_tmp6_ = g;
#line 341 "../src/game.vala"
		_tmp7_ = self->next_shape;
#line 341 "../src/game.vala"
		_tmp8_ = shape_copy (_tmp7_);
#line 341 "../src/game.vala"
		_g_object_unref0 (_tmp6_->next_shape);
#line 341 "../src/game.vala"
		_tmp6_->next_shape = _tmp8_;
#line 848 "game.c"
	}
	{
		gint x = 0;
#line 342 "../src/game.vala"
		x = 0;
#line 854 "game.c"
		{
			gboolean _tmp9_ = FALSE;
#line 342 "../src/game.vala"
			_tmp9_ = TRUE;
#line 342 "../src/game.vala"
			while (TRUE) {
#line 861 "game.c"
				gint _tmp11_;
				gint _tmp12_;
#line 342 "../src/game.vala"
				if (!_tmp9_) {
#line 866 "game.c"
					gint _tmp10_;
#line 342 "../src/game.vala"
					_tmp10_ = x;
#line 342 "../src/game.vala"
					x = _tmp10_ + 1;
#line 872 "game.c"
				}
#line 342 "../src/game.vala"
				_tmp9_ = FALSE;
#line 342 "../src/game.vala"
				_tmp11_ = game_get_width (self);
#line 342 "../src/game.vala"
				_tmp12_ = _tmp11_;
#line 342 "../src/game.vala"
				if (!(x < _tmp12_)) {
#line 342 "../src/game.vala"
					break;
#line 884 "game.c"
				}
				{
					gint y = 0;
#line 344 "../src/game.vala"
					y = 0;
#line 890 "game.c"
					{
						gboolean _tmp13_ = FALSE;
#line 344 "../src/game.vala"
						_tmp13_ = TRUE;
#line 344 "../src/game.vala"
						while (TRUE) {
#line 897 "game.c"
							gint _tmp15_;
							gint _tmp16_;
							Block** _tmp17_;
							gint _tmp17__length1;
							gint _tmp17__length2;
							Block* _tmp18_;
#line 344 "../src/game.vala"
							if (!_tmp13_) {
#line 906 "game.c"
								gint _tmp14_;
#line 344 "../src/game.vala"
								_tmp14_ = y;
#line 344 "../src/game.vala"
								y = _tmp14_ + 1;
#line 912 "game.c"
							}
#line 344 "../src/game.vala"
							_tmp13_ = FALSE;
#line 344 "../src/game.vala"
							_tmp15_ = game_get_height (self);
#line 344 "../src/game.vala"
							_tmp16_ = _tmp15_;
#line 344 "../src/game.vala"
							if (!(y < _tmp16_)) {
#line 344 "../src/game.vala"
								break;
#line 924 "game.c"
							}
#line 346 "../src/game.vala"
							_tmp17_ = self->blocks;
#line 346 "../src/game.vala"
							_tmp17__length1 = self->blocks_length1;
#line 346 "../src/game.vala"
							_tmp17__length2 = self->blocks_length2;
#line 346 "../src/game.vala"
							_tmp18_ = _tmp17_[(x * _tmp17__length2) + y];
#line 346 "../src/game.vala"
							if (_tmp18_ != NULL) {
#line 936 "game.c"
								Game* _tmp19_;
								Block** _tmp20_;
								gint _tmp20__length1;
								gint _tmp20__length2;
								Block** _tmp21_;
								gint _tmp21__length1;
								gint _tmp21__length2;
								Block* _tmp22_;
								Block* _tmp23_;
#line 347 "../src/game.vala"
								_tmp19_ = g;
#line 347 "../src/game.vala"
								_tmp20_ = _tmp19_->blocks;
#line 347 "../src/game.vala"
								_tmp20__length1 = _tmp19_->blocks_length1;
#line 347 "../src/game.vala"
								_tmp20__length2 = _tmp19_->blocks_length2;
#line 347 "../src/game.vala"
								_tmp21_ = self->blocks;
#line 347 "../src/game.vala"
								_tmp21__length1 = self->blocks_length1;
#line 347 "../src/game.vala"
								_tmp21__length2 = self->blocks_length2;
#line 347 "../src/game.vala"
								_tmp22_ = _tmp21_[(x * _tmp21__length2) + y];
#line 347 "../src/game.vala"
								_tmp23_ = block_copy (_tmp22_);
#line 347 "../src/game.vala"
								_g_object_unref0 (_tmp20_[(x * _tmp20__length2) + y]);
#line 347 "../src/game.vala"
								_tmp20_[(x * _tmp20__length2) + y] = _tmp23_;
#line 968 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 350 "../src/game.vala"
	_tmp24_ = g;
#line 350 "../src/game.vala"
	_tmp24_->n_lines_destroyed = self->n_lines_destroyed;
#line 351 "../src/game.vala"
	_tmp25_ = g;
#line 351 "../src/game.vala"
	_tmp25_->score = self->score;
#line 352 "../src/game.vala"
	_tmp26_ = g;
#line 352 "../src/game.vala"
	_tmp26_->priv->starting_level = self->priv->starting_level;
#line 353 "../src/game.vala"
	_tmp27_ = g;
#line 353 "../src/game.vala"
	_tmp27_->priv->pick_difficult_blocks = self->priv->pick_difficult_blocks;
#line 354 "../src/game.vala"
	_tmp28_ = g;
#line 354 "../src/game.vala"
	_tmp28_->priv->fast_move_direction = self->priv->fast_move_direction;
#line 355 "../src/game.vala"
	_tmp29_ = g;
#line 355 "../src/game.vala"
	_tmp29_->priv->fast_forward = self->priv->fast_forward;
#line 356 "../src/game.vala"
	_tmp30_ = g;
#line 356 "../src/game.vala"
	_tmp30_->priv->has_started = self->priv->has_started;
#line 357 "../src/game.vala"
	_tmp31_ = g;
#line 357 "../src/game.vala"
	_tmp31_->priv->_paused = self->priv->_paused;
#line 358 "../src/game.vala"
	_tmp32_ = g;
#line 358 "../src/game.vala"
	_tmp32_->game_over = self->game_over;
#line 360 "../src/game.vala"
	result = g;
#line 360 "../src/game.vala"
	return result;
#line 1016 "game.c"
}

void
game_start (Game* self)
{
#line 363 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 365 "../src/game.vala"
	self->priv->has_started = TRUE;
#line 366 "../src/game.vala"
	game_make_next_shape (self);
#line 367 "../src/game.vala"
	game_add_shape (self);
#line 368 "../src/game.vala"
	game_setup_drop_timer (self);
#line 369 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_STARTED_SIGNAL], 0);
#line 370 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_PAUSE_CHANGED_SIGNAL], 0);
#line 1036 "game.c"
}

gboolean
game_move_left (Game* self)
{
	gboolean result;
#line 373 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 375 "../src/game.vala"
	result = game_move_direction (self, -1);
#line 375 "../src/game.vala"
	return result;
#line 1049 "game.c"
}

gboolean
game_move_right (Game* self)
{
	gboolean result;
#line 378 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 380 "../src/game.vala"
	result = game_move_direction (self, 1);
#line 380 "../src/game.vala"
	return result;
#line 1062 "game.c"
}

gboolean
game_stop_moving (Game* self)
{
	gboolean result;
#line 383 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 385 "../src/game.vala"
	if (self->game_over) {
#line 386 "../src/game.vala"
		result = FALSE;
#line 386 "../src/game.vala"
		return result;
#line 1077 "game.c"
	}
#line 388 "../src/game.vala"
	if (self->priv->fast_move_timeout != ((guint) 0)) {
#line 389 "../src/game.vala"
		g_source_remove (self->priv->fast_move_timeout);
#line 1083 "game.c"
	}
#line 390 "../src/game.vala"
	self->priv->fast_move_timeout = (guint) 0;
#line 391 "../src/game.vala"
	self->priv->fast_move_direction = 0;
#line 393 "../src/game.vala"
	result = TRUE;
#line 393 "../src/game.vala"
	return result;
#line 1093 "game.c"
}

gboolean
game_rotate_left (Game* self)
{
	gboolean result;
#line 396 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 398 "../src/game.vala"
	result = game_move_shape (self, 0, 0, 1);
#line 398 "../src/game.vala"
	return result;
#line 1106 "game.c"
}

gboolean
game_rotate_right (Game* self)
{
	gboolean result;
#line 401 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 403 "../src/game.vala"
	result = game_move_shape (self, 0, 0, -1);
#line 403 "../src/game.vala"
	return result;
#line 1119 "game.c"
}

void
game_set_fast_forward (Game* self,
                       gboolean enable)
{
	gboolean _tmp0_ = FALSE;
#line 406 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 408 "../src/game.vala"
	if (self->priv->fast_forward == enable) {
#line 408 "../src/game.vala"
		_tmp0_ = TRUE;
#line 1133 "game.c"
	} else {
#line 408 "../src/game.vala"
		_tmp0_ = self->game_over;
#line 1137 "game.c"
	}
#line 408 "../src/game.vala"
	if (_tmp0_) {
#line 409 "../src/game.vala"
		return;
#line 1143 "game.c"
	}
#line 410 "../src/game.vala"
	if (enable) {
#line 411 "../src/game.vala"
		if (!game_move_shape (self, 0, 1, 0)) {
#line 412 "../src/game.vala"
			return;
#line 1151 "game.c"
		}
	}
#line 413 "../src/game.vala"
	self->priv->fast_forward = enable;
#line 414 "../src/game.vala"
	game_setup_drop_timer (self);
#line 1158 "game.c"
}

void
game_drop (Game* self)
{
	Shape* _tmp0_;
#line 417 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 419 "../src/game.vala"
	_tmp0_ = self->shape;
#line 419 "../src/game.vala"
	if (_tmp0_ == NULL) {
#line 420 "../src/game.vala"
		return;
#line 1173 "game.c"
	}
#line 422 "../src/game.vala"
	while (TRUE) {
#line 422 "../src/game.vala"
		if (!game_move_shape (self, 0, 1, 0)) {
#line 422 "../src/game.vala"
			break;
#line 1181 "game.c"
		}
	}
#line 423 "../src/game.vala"
	game_fall_timeout_cb (self);
#line 1186 "game.c"
}

void
game_stop (Game* self)
{
#line 426 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 428 "../src/game.vala"
	if (self->priv->drop_timeout != ((guint) 0)) {
#line 429 "../src/game.vala"
		g_source_remove (self->priv->drop_timeout);
#line 1198 "game.c"
	}
}

static gboolean
_game_setup_fast_move_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = game_setup_fast_move_cb ((Game*) self);
#line 446 "../src/game.vala"
	return result;
#line 1209 "game.c"
}

static gboolean
game_move_direction (Game* self,
                     gint direction)
{
	gboolean result;
#line 432 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 434 "../src/game.vala"
	if (self->game_over) {
#line 435 "../src/game.vala"
		result = FALSE;
#line 435 "../src/game.vala"
		return result;
#line 1225 "game.c"
	}
#line 436 "../src/game.vala"
	if (self->priv->fast_move_direction == direction) {
#line 437 "../src/game.vala"
		result = TRUE;
#line 437 "../src/game.vala"
		return result;
#line 1233 "game.c"
	}
#line 439 "../src/game.vala"
	if (self->priv->fast_move_timeout != ((guint) 0)) {
#line 440 "../src/game.vala"
		g_source_remove (self->priv->fast_move_timeout);
#line 1239 "game.c"
	}
#line 441 "../src/game.vala"
	self->priv->fast_move_timeout = (guint) 0;
#line 442 "../src/game.vala"
	self->priv->fast_move_direction = direction;
#line 443 "../src/game.vala"
	if (!game_move (self)) {
#line 444 "../src/game.vala"
		result = FALSE;
#line 444 "../src/game.vala"
		return result;
#line 1251 "game.c"
	}
#line 446 "../src/game.vala"
	self->priv->fast_move_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _game_setup_fast_move_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 448 "../src/game.vala"
	result = TRUE;
#line 448 "../src/game.vala"
	return result;
#line 1259 "game.c"
}

static gboolean
_game_move_gsource_func (gpointer self)
{
	gboolean result;
	result = game_move ((Game*) self);
#line 455 "../src/game.vala"
	return result;
#line 1269 "game.c"
}

static gboolean
game_setup_fast_move_cb (Game* self)
{
	gboolean result;
#line 451 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 453 "../src/game.vala"
	if (!game_move (self)) {
#line 454 "../src/game.vala"
		result = FALSE;
#line 454 "../src/game.vala"
		return result;
#line 1284 "game.c"
	}
#line 455 "../src/game.vala"
	self->priv->fast_move_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 40, _game_move_gsource_func, g_object_ref (self), g_object_unref);
#line 457 "../src/game.vala"
	result = FALSE;
#line 457 "../src/game.vala"
	return result;
#line 1292 "game.c"
}

static gboolean
game_move (Game* self)
{
	gboolean result;
#line 460 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 462 "../src/game.vala"
	if (!game_move_shape (self, self->priv->fast_move_direction, 0, 0)) {
#line 464 "../src/game.vala"
		self->priv->fast_move_timeout = (guint) 0;
#line 465 "../src/game.vala"
		self->priv->fast_move_direction = 0;
#line 467 "../src/game.vala"
		result = FALSE;
#line 467 "../src/game.vala"
		return result;
#line 1311 "game.c"
	}
#line 470 "../src/game.vala"
	result = TRUE;
#line 470 "../src/game.vala"
	return result;
#line 1317 "game.c"
}

static gboolean
_game_fall_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = game_fall_timeout_cb ((Game*) self);
#line 486 "../src/game.vala"
	return result;
#line 1327 "game.c"
}

static void
game_setup_drop_timer (Game* self)
{
	gint timestep = 0;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 473 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 475 "../src/game.vala"
	_tmp0_ = game_get_level (self);
#line 475 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 475 "../src/game.vala"
	timestep = (gint) round (80 + (800.0 * pow (0.75, (gdouble) (_tmp1_ - 1))));
#line 476 "../src/game.vala"
	timestep = MAX (10, timestep);
#line 479 "../src/game.vala"
	if (self->priv->fast_forward) {
#line 480 "../src/game.vala"
		timestep = 80;
#line 1352 "game.c"
	}
#line 482 "../src/game.vala"
	if (self->priv->drop_timeout != ((guint) 0)) {
#line 483 "../src/game.vala"
		g_source_remove (self->priv->drop_timeout);
#line 1358 "game.c"
	}
#line 484 "../src/game.vala"
	self->priv->drop_timeout = (guint) 0;
#line 485 "../src/game.vala"
	_tmp2_ = game_get_paused (self);
#line 485 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 485 "../src/game.vala"
	if (!_tmp3_) {
#line 486 "../src/game.vala"
		self->priv->drop_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) timestep, _game_fall_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 1370 "game.c"
	}
}

static gboolean
game_fall_timeout_cb (Game* self)
{
	gboolean result;
#line 489 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 492 "../src/game.vala"
	if (!game_move_shape (self, 0, 1, 0)) {
#line 495 "../src/game.vala"
		game_land_shape (self);
#line 498 "../src/game.vala"
		game_add_shape (self);
#line 1386 "game.c"
	}
#line 501 "../src/game.vala"
	result = TRUE;
#line 501 "../src/game.vala"
	return result;
#line 1392 "game.c"
}

static void
game_make_next_shape (Game* self)
{
#line 504 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 506 "../src/game.vala"
	if (self->priv->pick_difficult_blocks) {
#line 1402 "game.c"
		Shape* _tmp0_;
#line 508 "../src/game.vala"
		_tmp0_ = game_pick_difficult_shapes (self);
#line 508 "../src/game.vala"
		_g_object_unref0 (self->next_shape);
#line 508 "../src/game.vala"
		self->next_shape = _tmp0_;
#line 1410 "game.c"
	} else {
		Shape* _tmp1_;
#line 512 "../src/game.vala"
		_tmp1_ = game_pick_random_shape (self);
#line 512 "../src/game.vala"
		_g_object_unref0 (self->next_shape);
#line 512 "../src/game.vala"
		self->next_shape = _tmp1_;
#line 1419 "game.c"
	}
}

static void
game_add_shape (Game* self)
{
	Shape* _tmp0_;
	Shape* _tmp1_;
	GList* _tmp2_;
#line 516 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 518 "../src/game.vala"
	_tmp0_ = self->next_shape;
#line 518 "../src/game.vala"
	self->next_shape = NULL;
#line 518 "../src/game.vala"
	_g_object_unref0 (self->shape);
#line 518 "../src/game.vala"
	self->shape = _tmp0_;
#line 520 "../src/game.vala"
	game_make_next_shape (self);
#line 522 "../src/game.vala"
	_tmp1_ = self->shape;
#line 522 "../src/game.vala"
	_tmp2_ = _tmp1_->blocks;
#line 1445 "game.c"
	{
		GList* b_collection = NULL;
		GList* b_it = NULL;
#line 522 "../src/game.vala"
		b_collection = _tmp2_;
#line 522 "../src/game.vala"
		for (b_it = b_collection; b_it != NULL; b_it = b_it->next) {
#line 1453 "game.c"
			Block* _tmp3_;
			Block* b = NULL;
#line 522 "../src/game.vala"
			_tmp3_ = _g_object_ref0 ((Block*) b_it->data);
#line 522 "../src/game.vala"
			b = _tmp3_;
#line 1460 "game.c"
			{
				gint x = 0;
				Shape* _tmp4_;
				Block* _tmp5_;
				gint y = 0;
				Shape* _tmp6_;
				Block* _tmp7_;
				gboolean _tmp8_ = FALSE;
#line 524 "../src/game.vala"
				_tmp4_ = self->shape;
#line 524 "../src/game.vala"
				_tmp5_ = b;
#line 524 "../src/game.vala"
				x = _tmp4_->x + _tmp5_->x;
#line 525 "../src/game.vala"
				_tmp6_ = self->shape;
#line 525 "../src/game.vala"
				_tmp7_ = b;
#line 525 "../src/game.vala"
				y = _tmp6_->y + _tmp7_->y;
#line 528 "../src/game.vala"
				if (y >= 0) {
#line 1483 "game.c"
					Block** _tmp9_;
					gint _tmp9__length1;
					gint _tmp9__length2;
					Block* _tmp10_;
#line 528 "../src/game.vala"
					_tmp9_ = self->blocks;
#line 528 "../src/game.vala"
					_tmp9__length1 = self->blocks_length1;
#line 528 "../src/game.vala"
					_tmp9__length2 = self->blocks_length2;
#line 528 "../src/game.vala"
					_tmp10_ = _tmp9_[(x * _tmp9__length2) + y];
#line 528 "../src/game.vala"
					_tmp8_ = _tmp10_ != NULL;
#line 1498 "game.c"
				} else {
#line 528 "../src/game.vala"
					_tmp8_ = FALSE;
#line 1502 "game.c"
				}
#line 528 "../src/game.vala"
				if (_tmp8_) {
#line 532 "../src/game.vala"
					if (self->priv->drop_timeout != ((guint) 0)) {
#line 533 "../src/game.vala"
						g_source_remove (self->priv->drop_timeout);
#line 1510 "game.c"
					}
#line 534 "../src/game.vala"
					self->priv->drop_timeout = (guint) 0;
#line 535 "../src/game.vala"
					_g_object_unref0 (self->shape);
#line 535 "../src/game.vala"
					self->shape = NULL;
#line 536 "../src/game.vala"
					self->game_over = TRUE;
#line 537 "../src/game.vala"
					g_signal_emit (self, game_signals[GAME_COMPLETE_SIGNAL], 0);
#line 538 "../src/game.vala"
					_g_object_unref0 (b);
#line 538 "../src/game.vala"
					return;
#line 1526 "game.c"
				}
#line 522 "../src/game.vala"
				_g_object_unref0 (b);
#line 1530 "game.c"
			}
		}
	}
#line 542 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_SHAPE_ADDED_SIGNAL], 0);
#line 1536 "game.c"
}

static Shape*
game_pick_random_shape (Game* self)
{
	Shape* _tmp0_;
	Shape* result;
#line 545 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 547 "../src/game.vala"
	_tmp0_ = game_make_shape (self, (gint) g_random_int_range ((gint32) 0, (gint32) NCOLORS), (gint) g_random_int_range ((gint32) 0, (gint32) 4));
#line 547 "../src/game.vala"
	result = _tmp0_;
#line 547 "../src/game.vala"
	return result;
#line 1552 "game.c"
}

static Shape*
game_pick_difficult_shapes (Game* self)
{
	gint* metrics = NULL;
	gint* _tmp0_;
	gint metrics_length1;
	gint _metrics_size_;
	gint* possible_types = NULL;
	gint* _tmp41_;
	gint possible_types_length1;
	gint _possible_types_size_;
	Shape* new_shape = NULL;
	Shape* _tmp63_;
	gint32 rnd = 0;
	Shape* result;
#line 550 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 553 "../src/game.vala"
	_tmp0_ = g_new0 (gint, NCOLORS);
#line 553 "../src/game.vala"
	metrics = _tmp0_;
#line 553 "../src/game.vala"
	metrics_length1 = NCOLORS;
#line 553 "../src/game.vala"
	_metrics_size_ = metrics_length1;
#line 1580 "game.c"
	{
		gint type = 0;
#line 554 "../src/game.vala"
		type = 0;
#line 1585 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 554 "../src/game.vala"
			_tmp1_ = TRUE;
#line 554 "../src/game.vala"
			while (TRUE) {
#line 1592 "game.c"
				gint* _tmp3_;
				gint _tmp3__length1;
#line 554 "../src/game.vala"
				if (!_tmp1_) {
#line 1597 "game.c"
					gint _tmp2_;
#line 554 "../src/game.vala"
					_tmp2_ = type;
#line 554 "../src/game.vala"
					type = _tmp2_ + 1;
#line 1603 "game.c"
				}
#line 554 "../src/game.vala"
				_tmp1_ = FALSE;
#line 554 "../src/game.vala"
				if (!(type < NCOLORS)) {
#line 554 "../src/game.vala"
					break;
#line 1611 "game.c"
				}
#line 556 "../src/game.vala"
				_tmp3_ = metrics;
#line 556 "../src/game.vala"
				_tmp3__length1 = metrics_length1;
#line 556 "../src/game.vala"
				_tmp3_[type] = -32000;
#line 1619 "game.c"
				{
					gint rotation = 0;
#line 557 "../src/game.vala"
					rotation = 0;
#line 1624 "game.c"
					{
						gboolean _tmp4_ = FALSE;
#line 557 "../src/game.vala"
						_tmp4_ = TRUE;
#line 557 "../src/game.vala"
						while (TRUE) {
#line 557 "../src/game.vala"
							if (!_tmp4_) {
#line 1633 "game.c"
								gint _tmp5_;
#line 557 "../src/game.vala"
								_tmp5_ = rotation;
#line 557 "../src/game.vala"
								rotation = _tmp5_ + 1;
#line 1639 "game.c"
							}
#line 557 "../src/game.vala"
							_tmp4_ = FALSE;
#line 557 "../src/game.vala"
							if (!(rotation < 4)) {
#line 557 "../src/game.vala"
								break;
#line 1647 "game.c"
							}
							{
								gint pos = 0;
#line 559 "../src/game.vala"
								pos = 0;
#line 1653 "game.c"
								{
									gboolean _tmp6_ = FALSE;
#line 559 "../src/game.vala"
									_tmp6_ = TRUE;
#line 559 "../src/game.vala"
									while (TRUE) {
#line 1660 "game.c"
										gint _tmp8_;
										gint _tmp9_;
										Game* g = NULL;
										Game* _tmp10_;
										Game* _tmp11_;
										Game* _tmp12_;
										Shape* _tmp13_;
										gboolean valid_position = FALSE;
										gint orig_lines = 0;
										Game* _tmp18_;
										Game* _tmp19_;
										gint metric = 0;
										Game* _tmp20_;
										gint* _tmp34_;
										gint _tmp34__length1;
										gint _tmp35_;
										Game* _tmp37_;
#line 559 "../src/game.vala"
										if (!_tmp6_) {
#line 1680 "game.c"
											gint _tmp7_;
#line 559 "../src/game.vala"
											_tmp7_ = pos;
#line 559 "../src/game.vala"
											pos = _tmp7_ + 1;
#line 1686 "game.c"
										}
#line 559 "../src/game.vala"
										_tmp6_ = FALSE;
#line 559 "../src/game.vala"
										_tmp8_ = game_get_width (self);
#line 559 "../src/game.vala"
										_tmp9_ = _tmp8_;
#line 559 "../src/game.vala"
										if (!(pos < _tmp9_)) {
#line 559 "../src/game.vala"
											break;
#line 1698 "game.c"
										}
#line 562 "../src/game.vala"
										_tmp10_ = game_copy (self);
#line 562 "../src/game.vala"
										g = _tmp10_;
#line 563 "../src/game.vala"
										_tmp11_ = g;
#line 563 "../src/game.vala"
										_tmp11_->priv->pick_difficult_blocks = FALSE;
#line 564 "../src/game.vala"
										_tmp12_ = g;
#line 564 "../src/game.vala"
										_tmp13_ = game_make_shape (self, type, rotation);
#line 564 "../src/game.vala"
										_g_object_unref0 (_tmp12_->shape);
#line 564 "../src/game.vala"
										_tmp12_->shape = _tmp13_;
#line 567 "../src/game.vala"
										valid_position = TRUE;
#line 568 "../src/game.vala"
										while (TRUE) {
#line 1720 "game.c"
											Game* _tmp14_;
#line 568 "../src/game.vala"
											_tmp14_ = g;
#line 568 "../src/game.vala"
											if (!game_move_shape (_tmp14_, -1, 0, 0)) {
#line 568 "../src/game.vala"
												break;
#line 1728 "game.c"
											}
										}
										{
											gint x = 0;
#line 569 "../src/game.vala"
											x = 0;
#line 1735 "game.c"
											{
												gboolean _tmp15_ = FALSE;
#line 569 "../src/game.vala"
												_tmp15_ = TRUE;
#line 569 "../src/game.vala"
												while (TRUE) {
#line 1742 "game.c"
													Game* _tmp17_;
#line 569 "../src/game.vala"
													if (!_tmp15_) {
#line 1746 "game.c"
														gint _tmp16_;
#line 569 "../src/game.vala"
														_tmp16_ = x;
#line 569 "../src/game.vala"
														x = _tmp16_ + 1;
#line 1752 "game.c"
													}
#line 569 "../src/game.vala"
													_tmp15_ = FALSE;
#line 569 "../src/game.vala"
													if (!(x < pos)) {
#line 569 "../src/game.vala"
														break;
#line 1760 "game.c"
													}
#line 571 "../src/game.vala"
													_tmp17_ = g;
#line 571 "../src/game.vala"
													if (!game_move_shape (_tmp17_, 1, 0, 0)) {
#line 573 "../src/game.vala"
														valid_position = FALSE;
#line 574 "../src/game.vala"
														break;
#line 1770 "game.c"
													}
												}
											}
										}
#line 578 "../src/game.vala"
										if (!valid_position) {
#line 579 "../src/game.vala"
											_g_object_unref0 (g);
#line 579 "../src/game.vala"
											break;
#line 1781 "game.c"
										}
#line 582 "../src/game.vala"
										_tmp18_ = g;
#line 582 "../src/game.vala"
										orig_lines = _tmp18_->n_lines_destroyed;
#line 583 "../src/game.vala"
										_tmp19_ = g;
#line 583 "../src/game.vala"
										game_drop (_tmp19_);
#line 586 "../src/game.vala"
										_tmp20_ = g;
#line 586 "../src/game.vala"
										metric = (_tmp20_->n_lines_destroyed - orig_lines) * 5000;
#line 1795 "game.c"
										{
											gint x = 0;
#line 589 "../src/game.vala"
											x = 0;
#line 1800 "game.c"
											{
												gboolean _tmp21_ = FALSE;
#line 589 "../src/game.vala"
												_tmp21_ = TRUE;
#line 589 "../src/game.vala"
												while (TRUE) {
#line 1807 "game.c"
													gint _tmp23_;
													gint _tmp24_;
													gint y = 0;
													gint _tmp32_;
													gint _tmp33_;
#line 589 "../src/game.vala"
													if (!_tmp21_) {
#line 1815 "game.c"
														gint _tmp22_;
#line 589 "../src/game.vala"
														_tmp22_ = x;
#line 589 "../src/game.vala"
														x = _tmp22_ + 1;
#line 1821 "game.c"
													}
#line 589 "../src/game.vala"
													_tmp21_ = FALSE;
#line 589 "../src/game.vala"
													_tmp23_ = game_get_width (self);
#line 589 "../src/game.vala"
													_tmp24_ = _tmp23_;
#line 589 "../src/game.vala"
													if (!(x < _tmp24_)) {
#line 589 "../src/game.vala"
														break;
#line 1833 "game.c"
													}
													{
														gboolean _tmp25_ = FALSE;
#line 592 "../src/game.vala"
														y = 0;
#line 592 "../src/game.vala"
														_tmp25_ = TRUE;
#line 592 "../src/game.vala"
														while (TRUE) {
#line 1843 "game.c"
															gint _tmp27_;
															gint _tmp28_;
															Game* _tmp29_;
															Block** _tmp30_;
															gint _tmp30__length1;
															gint _tmp30__length2;
															Block* _tmp31_;
#line 592 "../src/game.vala"
															if (!_tmp25_) {
#line 1853 "game.c"
																gint _tmp26_;
#line 592 "../src/game.vala"
																_tmp26_ = y;
#line 592 "../src/game.vala"
																y = _tmp26_ + 1;
#line 1859 "game.c"
															}
#line 592 "../src/game.vala"
															_tmp25_ = FALSE;
#line 592 "../src/game.vala"
															_tmp27_ = game_get_height (self);
#line 592 "../src/game.vala"
															_tmp28_ = _tmp27_;
#line 592 "../src/game.vala"
															if (!(y < _tmp28_)) {
#line 592 "../src/game.vala"
																break;
#line 1871 "game.c"
															}
#line 594 "../src/game.vala"
															_tmp29_ = g;
#line 594 "../src/game.vala"
															_tmp30_ = _tmp29_->blocks;
#line 594 "../src/game.vala"
															_tmp30__length1 = _tmp29_->blocks_length1;
#line 594 "../src/game.vala"
															_tmp30__length2 = _tmp29_->blocks_length2;
#line 594 "../src/game.vala"
															_tmp31_ = _tmp30_[(x * _tmp30__length2) + y];
#line 594 "../src/game.vala"
															if (_tmp31_ != NULL) {
#line 595 "../src/game.vala"
																break;
#line 1887 "game.c"
															}
														}
													}
#line 598 "../src/game.vala"
													_tmp32_ = game_get_height (self);
#line 598 "../src/game.vala"
													_tmp33_ = _tmp32_;
#line 598 "../src/game.vala"
													metric -= 5 * (_tmp33_ - y);
#line 1897 "game.c"
												}
											}
										}
#line 601 "../src/game.vala"
										_tmp34_ = metrics;
#line 601 "../src/game.vala"
										_tmp34__length1 = metrics_length1;
#line 601 "../src/game.vala"
										_tmp35_ = _tmp34_[type];
#line 601 "../src/game.vala"
										if (metric > _tmp35_) {
#line 1909 "game.c"
											gint* _tmp36_;
											gint _tmp36__length1;
#line 602 "../src/game.vala"
											_tmp36_ = metrics;
#line 602 "../src/game.vala"
											_tmp36__length1 = metrics_length1;
#line 602 "../src/game.vala"
											_tmp36_[type] = metric;
#line 1918 "game.c"
										}
#line 605 "../src/game.vala"
										_tmp37_ = g;
#line 605 "../src/game.vala"
										game_stop (_tmp37_);
#line 559 "../src/game.vala"
										_g_object_unref0 (g);
#line 1926 "game.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
#line 611 "../src/game.vala"
		i = 0;
#line 1940 "game.c"
		{
			gboolean _tmp38_ = FALSE;
#line 611 "../src/game.vala"
			_tmp38_ = TRUE;
#line 611 "../src/game.vala"
			while (TRUE) {
#line 1947 "game.c"
				gint* _tmp40_;
				gint _tmp40__length1;
#line 611 "../src/game.vala"
				if (!_tmp38_) {
#line 1952 "game.c"
					gint _tmp39_;
#line 611 "../src/game.vala"
					_tmp39_ = i;
#line 611 "../src/game.vala"
					i = _tmp39_ + 1;
#line 1958 "game.c"
				}
#line 611 "../src/game.vala"
				_tmp38_ = FALSE;
#line 611 "../src/game.vala"
				if (!(i < NCOLORS)) {
#line 611 "../src/game.vala"
					break;
#line 1966 "game.c"
				}
#line 612 "../src/game.vala"
				_tmp40_ = metrics;
#line 612 "../src/game.vala"
				_tmp40__length1 = metrics_length1;
#line 612 "../src/game.vala"
				_tmp40_[i] += (gint) g_random_int_range ((gint32) -2, (gint32) 2);
#line 1974 "game.c"
			}
		}
	}
#line 615 "../src/game.vala"
	_tmp41_ = g_new0 (gint, NCOLORS);
#line 615 "../src/game.vala"
	possible_types = _tmp41_;
#line 615 "../src/game.vala"
	possible_types_length1 = NCOLORS;
#line 615 "../src/game.vala"
	_possible_types_size_ = possible_types_length1;
#line 1986 "game.c"
	{
		gint i = 0;
#line 616 "../src/game.vala"
		i = 0;
#line 1991 "game.c"
		{
			gboolean _tmp42_ = FALSE;
#line 616 "../src/game.vala"
			_tmp42_ = TRUE;
#line 616 "../src/game.vala"
			while (TRUE) {
#line 1998 "game.c"
				gint* _tmp44_;
				gint _tmp44__length1;
#line 616 "../src/game.vala"
				if (!_tmp42_) {
#line 2003 "game.c"
					gint _tmp43_;
#line 616 "../src/game.vala"
					_tmp43_ = i;
#line 616 "../src/game.vala"
					i = _tmp43_ + 1;
#line 2009 "game.c"
				}
#line 616 "../src/game.vala"
				_tmp42_ = FALSE;
#line 616 "../src/game.vala"
				if (!(i < NCOLORS)) {
#line 616 "../src/game.vala"
					break;
#line 2017 "game.c"
				}
#line 617 "../src/game.vala"
				_tmp44_ = possible_types;
#line 617 "../src/game.vala"
				_tmp44__length1 = possible_types_length1;
#line 617 "../src/game.vala"
				_tmp44_[i] = i;
#line 2025 "game.c"
			}
		}
	}
	{
		gint i = 0;
#line 618 "../src/game.vala"
		i = 0;
#line 2033 "game.c"
		{
			gboolean _tmp45_ = FALSE;
#line 618 "../src/game.vala"
			_tmp45_ = TRUE;
#line 618 "../src/game.vala"
			while (TRUE) {
#line 618 "../src/game.vala"
				if (!_tmp45_) {
#line 2042 "game.c"
					gint _tmp46_;
#line 618 "../src/game.vala"
					_tmp46_ = i;
#line 618 "../src/game.vala"
					i = _tmp46_ + 1;
#line 2048 "game.c"
				}
#line 618 "../src/game.vala"
				_tmp45_ = FALSE;
#line 618 "../src/game.vala"
				if (!(i < NCOLORS)) {
#line 618 "../src/game.vala"
					break;
#line 2056 "game.c"
				}
				{
					gint j = 0;
#line 620 "../src/game.vala"
					j = 0;
#line 2062 "game.c"
					{
						gboolean _tmp47_ = FALSE;
#line 620 "../src/game.vala"
						_tmp47_ = TRUE;
#line 620 "../src/game.vala"
						while (TRUE) {
#line 2069 "game.c"
							gint* _tmp49_;
							gint _tmp49__length1;
							gint* _tmp50_;
							gint _tmp50__length1;
							gint _tmp51_;
							gint _tmp52_;
							gint* _tmp53_;
							gint _tmp53__length1;
							gint* _tmp54_;
							gint _tmp54__length1;
							gint _tmp55_;
							gint _tmp56_;
#line 620 "../src/game.vala"
							if (!_tmp47_) {
#line 2084 "game.c"
								gint _tmp48_;
#line 620 "../src/game.vala"
								_tmp48_ = j;
#line 620 "../src/game.vala"
								j = _tmp48_ + 1;
#line 2090 "game.c"
							}
#line 620 "../src/game.vala"
							_tmp47_ = FALSE;
#line 620 "../src/game.vala"
							if (!(j < (NCOLORS - 1))) {
#line 620 "../src/game.vala"
								break;
#line 2098 "game.c"
							}
#line 622 "../src/game.vala"
							_tmp49_ = metrics;
#line 622 "../src/game.vala"
							_tmp49__length1 = metrics_length1;
#line 622 "../src/game.vala"
							_tmp50_ = possible_types;
#line 622 "../src/game.vala"
							_tmp50__length1 = possible_types_length1;
#line 622 "../src/game.vala"
							_tmp51_ = _tmp50_[j];
#line 622 "../src/game.vala"
							_tmp52_ = _tmp49_[_tmp51_];
#line 622 "../src/game.vala"
							_tmp53_ = metrics;
#line 622 "../src/game.vala"
							_tmp53__length1 = metrics_length1;
#line 622 "../src/game.vala"
							_tmp54_ = possible_types;
#line 622 "../src/game.vala"
							_tmp54__length1 = possible_types_length1;
#line 622 "../src/game.vala"
							_tmp55_ = _tmp54_[j + 1];
#line 622 "../src/game.vala"
							_tmp56_ = _tmp53_[_tmp55_];
#line 622 "../src/game.vala"
							if (_tmp52_ > _tmp56_) {
#line 2126 "game.c"
								gint t = 0;
								gint* _tmp57_;
								gint _tmp57__length1;
								gint _tmp58_;
								gint* _tmp59_;
								gint _tmp59__length1;
								gint* _tmp60_;
								gint _tmp60__length1;
								gint _tmp61_;
								gint* _tmp62_;
								gint _tmp62__length1;
#line 624 "../src/game.vala"
								_tmp57_ = possible_types;
#line 624 "../src/game.vala"
								_tmp57__length1 = possible_types_length1;
#line 624 "../src/game.vala"
								_tmp58_ = _tmp57_[j];
#line 624 "../src/game.vala"
								t = _tmp58_;
#line 625 "../src/game.vala"
								_tmp59_ = possible_types;
#line 625 "../src/game.vala"
								_tmp59__length1 = possible_types_length1;
#line 625 "../src/game.vala"
								_tmp60_ = possible_types;
#line 625 "../src/game.vala"
								_tmp60__length1 = possible_types_length1;
#line 625 "../src/game.vala"
								_tmp61_ = _tmp60_[j + 1];
#line 625 "../src/game.vala"
								_tmp59_[j] = _tmp61_;
#line 626 "../src/game.vala"
								_tmp62_ = possible_types;
#line 626 "../src/game.vala"
								_tmp62__length1 = possible_types_length1;
#line 626 "../src/game.vala"
								_tmp62_[j + 1] = t;
#line 2164 "game.c"
							}
						}
					}
				}
			}
		}
	}
#line 631 "../src/game.vala"
	_tmp63_ = shape_new ();
#line 631 "../src/game.vala"
	new_shape = _tmp63_;
#line 633 "../src/game.vala"
	rnd = g_random_int_range ((gint32) 0, (gint32) 99);
#line 634 "../src/game.vala"
	if (rnd < ((gint32) 75)) {
#line 2180 "game.c"
		gint* _tmp64_;
		gint _tmp64__length1;
		gint _tmp65_;
		Shape* _tmp66_;
#line 635 "../src/game.vala"
		_tmp64_ = possible_types;
#line 635 "../src/game.vala"
		_tmp64__length1 = possible_types_length1;
#line 635 "../src/game.vala"
		_tmp65_ = _tmp64_[0];
#line 635 "../src/game.vala"
		_tmp66_ = game_make_shape (self, _tmp65_, (gint) g_random_int_range ((gint32) 0, (gint32) 4));
#line 635 "../src/game.vala"
		_g_object_unref0 (new_shape);
#line 635 "../src/game.vala"
		new_shape = _tmp66_;
#line 2197 "game.c"
	} else {
#line 636 "../src/game.vala"
		if (rnd < ((gint32) 92)) {
#line 2201 "game.c"
			gint* _tmp67_;
			gint _tmp67__length1;
			gint _tmp68_;
			Shape* _tmp69_;
#line 637 "../src/game.vala"
			_tmp67_ = possible_types;
#line 637 "../src/game.vala"
			_tmp67__length1 = possible_types_length1;
#line 637 "../src/game.vala"
			_tmp68_ = _tmp67_[1];
#line 637 "../src/game.vala"
			_tmp69_ = game_make_shape (self, _tmp68_, (gint) g_random_int_range ((gint32) 0, (gint32) 4));
#line 637 "../src/game.vala"
			_g_object_unref0 (new_shape);
#line 637 "../src/game.vala"
			new_shape = _tmp69_;
#line 2218 "game.c"
		} else {
#line 638 "../src/game.vala"
			if (rnd < ((gint32) 98)) {
#line 2222 "game.c"
				gint* _tmp70_;
				gint _tmp70__length1;
				gint _tmp71_;
				Shape* _tmp72_;
#line 639 "../src/game.vala"
				_tmp70_ = possible_types;
#line 639 "../src/game.vala"
				_tmp70__length1 = possible_types_length1;
#line 639 "../src/game.vala"
				_tmp71_ = _tmp70_[2];
#line 639 "../src/game.vala"
				_tmp72_ = game_make_shape (self, _tmp71_, (gint) g_random_int_range ((gint32) 0, (gint32) 4));
#line 639 "../src/game.vala"
				_g_object_unref0 (new_shape);
#line 639 "../src/game.vala"
				new_shape = _tmp72_;
#line 2239 "game.c"
			} else {
				gint* _tmp73_;
				gint _tmp73__length1;
				gint _tmp74_;
				Shape* _tmp75_;
#line 641 "../src/game.vala"
				_tmp73_ = possible_types;
#line 641 "../src/game.vala"
				_tmp73__length1 = possible_types_length1;
#line 641 "../src/game.vala"
				_tmp74_ = _tmp73_[3];
#line 641 "../src/game.vala"
				_tmp75_ = game_make_shape (self, _tmp74_, (gint) g_random_int_range ((gint32) 0, (gint32) 4));
#line 641 "../src/game.vala"
				_g_object_unref0 (new_shape);
#line 641 "../src/game.vala"
				new_shape = _tmp75_;
#line 2257 "game.c"
			}
		}
	}
#line 646 "../src/game.vala"
	result = new_shape;
#line 646 "../src/game.vala"
	possible_types = (g_free (possible_types), NULL);
#line 646 "../src/game.vala"
	metrics = (g_free (metrics), NULL);
#line 646 "../src/game.vala"
	return result;
#line 2269 "game.c"
}

static Shape*
game_make_shape (Game* self,
                 gint type,
                 gint rotation)
{
	Shape* shape = NULL;
	Shape* _tmp0_;
	Shape* _tmp1_;
	Shape* _tmp2_;
	gint offset = 0;
	Shape* _tmp3_;
	Shape* _tmp4_;
	gint min_width = 0;
	gint max_width = 0;
	gint min_height = 0;
	gint max_height = 0;
	gint block_width = 0;
	Shape* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	Shape* _tmp21_;
	Shape* result;
#line 649 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 651 "../src/game.vala"
	_tmp0_ = shape_new ();
#line 651 "../src/game.vala"
	shape = _tmp0_;
#line 652 "../src/game.vala"
	_tmp1_ = shape;
#line 652 "../src/game.vala"
	_tmp1_->type = type;
#line 653 "../src/game.vala"
	_tmp2_ = shape;
#line 653 "../src/game.vala"
	_tmp2_->rotation = rotation;
#line 656 "../src/game.vala"
	_tmp3_ = shape;
#line 656 "../src/game.vala"
	_tmp4_ = shape;
#line 656 "../src/game.vala"
	offset = (_tmp3_->type * 64) + (_tmp4_->rotation * 16);
#line 657 "../src/game.vala"
	min_width = 4;
#line 657 "../src/game.vala"
	max_width = 0;
#line 657 "../src/game.vala"
	min_height = 4;
#line 657 "../src/game.vala"
	max_height = 0;
#line 2322 "game.c"
	{
		gint x = 0;
#line 658 "../src/game.vala"
		x = 0;
#line 2327 "game.c"
		{
			gboolean _tmp5_ = FALSE;
#line 658 "../src/game.vala"
			_tmp5_ = TRUE;
#line 658 "../src/game.vala"
			while (TRUE) {
#line 658 "../src/game.vala"
				if (!_tmp5_) {
#line 2336 "game.c"
					gint _tmp6_;
#line 658 "../src/game.vala"
					_tmp6_ = x;
#line 658 "../src/game.vala"
					x = _tmp6_ + 1;
#line 2342 "game.c"
				}
#line 658 "../src/game.vala"
				_tmp5_ = FALSE;
#line 658 "../src/game.vala"
				if (!(x < 4)) {
#line 658 "../src/game.vala"
					break;
#line 2350 "game.c"
				}
				{
					gint y = 0;
#line 660 "../src/game.vala"
					y = 0;
#line 2356 "game.c"
					{
						gboolean _tmp7_ = FALSE;
#line 660 "../src/game.vala"
						_tmp7_ = TRUE;
#line 660 "../src/game.vala"
						while (TRUE) {
#line 2363 "game.c"
							gint _tmp9_;
							Block* b = NULL;
							Block* _tmp10_;
							Block* _tmp11_;
							Shape* _tmp12_;
							Block* _tmp13_;
							Block* _tmp14_;
							Shape* _tmp15_;
							Block* _tmp16_;
							Block* _tmp17_;
#line 660 "../src/game.vala"
							if (!_tmp7_) {
#line 2376 "game.c"
								gint _tmp8_;
#line 660 "../src/game.vala"
								_tmp8_ = y;
#line 660 "../src/game.vala"
								y = _tmp8_ + 1;
#line 2382 "game.c"
							}
#line 660 "../src/game.vala"
							_tmp7_ = FALSE;
#line 660 "../src/game.vala"
							if (!(y < 4)) {
#line 660 "../src/game.vala"
								break;
#line 2390 "game.c"
							}
#line 662 "../src/game.vala"
							_tmp9_ = block_table[(offset + (y * 4)) + x];
#line 662 "../src/game.vala"
							if (_tmp9_ == 0) {
#line 663 "../src/game.vala"
								continue;
#line 2398 "game.c"
							}
#line 665 "../src/game.vala"
							min_width = MIN (x, min_width);
#line 666 "../src/game.vala"
							max_width = MAX (x + 1, max_width);
#line 667 "../src/game.vala"
							min_height = MIN (y, min_height);
#line 668 "../src/game.vala"
							max_height = MAX (y + 1, max_height);
#line 670 "../src/game.vala"
							_tmp10_ = block_new ();
#line 670 "../src/game.vala"
							b = _tmp10_;
#line 671 "../src/game.vala"
							_tmp11_ = b;
#line 671 "../src/game.vala"
							_tmp12_ = shape;
#line 671 "../src/game.vala"
							_tmp11_->color = _tmp12_->type;
#line 672 "../src/game.vala"
							_tmp13_ = b;
#line 672 "../src/game.vala"
							_tmp13_->x = x;
#line 673 "../src/game.vala"
							_tmp14_ = b;
#line 673 "../src/game.vala"
							_tmp14_->y = y;
#line 674 "../src/game.vala"
							_tmp15_ = shape;
#line 674 "../src/game.vala"
							_tmp16_ = b;
#line 674 "../src/game.vala"
							_tmp17_ = _g_object_ref0 (_tmp16_);
#line 674 "../src/game.vala"
							_tmp15_->blocks = g_list_append (_tmp15_->blocks, _tmp17_);
#line 660 "../src/game.vala"
							_g_object_unref0 (b);
#line 2436 "game.c"
						}
					}
				}
			}
		}
	}
#line 677 "../src/game.vala"
	block_width = max_width - min_width;
#line 678 "../src/game.vala"
	_tmp18_ = shape;
#line 678 "../src/game.vala"
	_tmp19_ = game_get_width (self);
#line 678 "../src/game.vala"
	_tmp20_ = _tmp19_;
#line 678 "../src/game.vala"
	_tmp18_->x = ((_tmp20_ - block_width) / 2) - min_width;
#line 679 "../src/game.vala"
	_tmp21_ = shape;
#line 679 "../src/game.vala"
	_tmp21_->y = -min_height;
#line 681 "../src/game.vala"
	result = shape;
#line 681 "../src/game.vala"
	return result;
#line 2461 "game.c"
}

static void
game_land_shape (Game* self)
{
	Shape* _tmp0_;
	GList* _tmp1_;
	gint fall_distance = 0;
	gint* lines = NULL;
	gint* _tmp14_;
	gint lines_length1;
	gint _lines_size_;
	gint n_lines = 0;
	gboolean base_line_destroyed = FALSE;
	gint _tmp29_;
	GList* line_blocks = NULL;
	gint old_level = 0;
	gint _tmp65_;
	gint _tmp66_;
	gint _tmp77_;
	gint _tmp78_;
	gint* _tmp79_;
	gint _tmp79__length1;
	GList* _tmp80_;
#line 684 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 687 "../src/game.vala"
	_tmp0_ = self->shape;
#line 687 "../src/game.vala"
	_tmp1_ = _tmp0_->blocks;
#line 2492 "game.c"
	{
		GList* b_collection = NULL;
		GList* b_it = NULL;
#line 687 "../src/game.vala"
		b_collection = _tmp1_;
#line 687 "../src/game.vala"
		for (b_it = b_collection; b_it != NULL; b_it = b_it->next) {
#line 2500 "game.c"
			Block* _tmp2_;
			Block* b = NULL;
#line 687 "../src/game.vala"
			_tmp2_ = _g_object_ref0 ((Block*) b_it->data);
#line 687 "../src/game.vala"
			b = _tmp2_;
#line 2507 "game.c"
			{
				Block* _tmp3_;
				Block* _tmp4_;
				Shape* _tmp5_;
				Block* _tmp6_;
				Block* _tmp7_;
				Shape* _tmp8_;
				Block** _tmp9_;
				gint _tmp9__length1;
				gint _tmp9__length2;
				Block* _tmp10_;
				Block* _tmp11_;
				Block* _tmp12_;
				Block* _tmp13_;
#line 689 "../src/game.vala"
				_tmp3_ = b;
#line 689 "../src/game.vala"
				_tmp4_ = b;
#line 689 "../src/game.vala"
				_tmp5_ = self->shape;
#line 689 "../src/game.vala"
				_tmp4_->x = _tmp4_->x + _tmp5_->x;
#line 690 "../src/game.vala"
				_tmp6_ = b;
#line 690 "../src/game.vala"
				_tmp7_ = b;
#line 690 "../src/game.vala"
				_tmp8_ = self->shape;
#line 690 "../src/game.vala"
				_tmp7_->y = _tmp7_->y + _tmp8_->y;
#line 691 "../src/game.vala"
				_tmp9_ = self->blocks;
#line 691 "../src/game.vala"
				_tmp9__length1 = self->blocks_length1;
#line 691 "../src/game.vala"
				_tmp9__length2 = self->blocks_length2;
#line 691 "../src/game.vala"
				_tmp10_ = b;
#line 691 "../src/game.vala"
				_tmp11_ = b;
#line 691 "../src/game.vala"
				_tmp12_ = b;
#line 691 "../src/game.vala"
				_tmp13_ = _g_object_ref0 (_tmp12_);
#line 691 "../src/game.vala"
				_g_object_unref0 (_tmp9_[(_tmp10_->x * _tmp9__length2) + _tmp11_->y]);
#line 691 "../src/game.vala"
				_tmp9_[(_tmp10_->x * _tmp9__length2) + _tmp11_->y] = _tmp13_;
#line 687 "../src/game.vala"
				_g_object_unref0 (b);
#line 2558 "game.c"
			}
		}
	}
#line 694 "../src/game.vala"
	fall_distance = 0;
#line 695 "../src/game.vala"
	_tmp14_ = g_new0 (gint, 4);
#line 695 "../src/game.vala"
	lines = _tmp14_;
#line 695 "../src/game.vala"
	lines_length1 = 4;
#line 695 "../src/game.vala"
	_lines_size_ = lines_length1;
#line 696 "../src/game.vala"
	n_lines = 0;
#line 697 "../src/game.vala"
	base_line_destroyed = FALSE;
#line 2576 "game.c"
	{
		gint y = 0;
		gint _tmp15_;
		gint _tmp16_;
#line 698 "../src/game.vala"
		_tmp15_ = game_get_height (self);
#line 698 "../src/game.vala"
		_tmp16_ = _tmp15_;
#line 698 "../src/game.vala"
		y = _tmp16_ - 1;
#line 2587 "game.c"
		{
			gboolean _tmp17_ = FALSE;
#line 698 "../src/game.vala"
			_tmp17_ = TRUE;
#line 698 "../src/game.vala"
			while (TRUE) {
#line 2594 "game.c"
				gboolean explode = FALSE;
#line 698 "../src/game.vala"
				if (!_tmp17_) {
#line 2598 "game.c"
					gint _tmp18_;
#line 698 "../src/game.vala"
					_tmp18_ = y;
#line 698 "../src/game.vala"
					y = _tmp18_ - 1;
#line 2604 "game.c"
				}
#line 698 "../src/game.vala"
				_tmp17_ = FALSE;
#line 698 "../src/game.vala"
				if (!(y >= 0)) {
#line 698 "../src/game.vala"
					break;
#line 2612 "game.c"
				}
#line 700 "../src/game.vala"
				explode = TRUE;
#line 2616 "game.c"
				{
					gint x = 0;
#line 701 "../src/game.vala"
					x = 0;
#line 2621 "game.c"
					{
						gboolean _tmp19_ = FALSE;
#line 701 "../src/game.vala"
						_tmp19_ = TRUE;
#line 701 "../src/game.vala"
						while (TRUE) {
#line 2628 "game.c"
							gint _tmp21_;
							gint _tmp22_;
							Block** _tmp23_;
							gint _tmp23__length1;
							gint _tmp23__length2;
							Block* _tmp24_;
#line 701 "../src/game.vala"
							if (!_tmp19_) {
#line 2637 "game.c"
								gint _tmp20_;
#line 701 "../src/game.vala"
								_tmp20_ = x;
#line 701 "../src/game.vala"
								x = _tmp20_ + 1;
#line 2643 "game.c"
							}
#line 701 "../src/game.vala"
							_tmp19_ = FALSE;
#line 701 "../src/game.vala"
							_tmp21_ = game_get_width (self);
#line 701 "../src/game.vala"
							_tmp22_ = _tmp21_;
#line 701 "../src/game.vala"
							if (!(x < _tmp22_)) {
#line 701 "../src/game.vala"
								break;
#line 2655 "game.c"
							}
#line 703 "../src/game.vala"
							_tmp23_ = self->blocks;
#line 703 "../src/game.vala"
							_tmp23__length1 = self->blocks_length1;
#line 703 "../src/game.vala"
							_tmp23__length2 = self->blocks_length2;
#line 703 "../src/game.vala"
							_tmp24_ = _tmp23_[(x * _tmp23__length2) + y];
#line 703 "../src/game.vala"
							if (_tmp24_ == NULL) {
#line 705 "../src/game.vala"
								explode = FALSE;
#line 706 "../src/game.vala"
								break;
#line 2671 "game.c"
							}
						}
					}
				}
#line 710 "../src/game.vala"
				if (explode) {
#line 2678 "game.c"
					gint _tmp25_;
					gint _tmp26_;
					gint* _tmp27_;
					gint _tmp27__length1;
					gint _tmp28_;
#line 712 "../src/game.vala"
					_tmp25_ = game_get_height (self);
#line 712 "../src/game.vala"
					_tmp26_ = _tmp25_;
#line 712 "../src/game.vala"
					if (y == (_tmp26_ - 1)) {
#line 713 "../src/game.vala"
						base_line_destroyed = TRUE;
#line 2692 "game.c"
					}
#line 714 "../src/game.vala"
					_tmp27_ = lines;
#line 714 "../src/game.vala"
					_tmp27__length1 = lines_length1;
#line 714 "../src/game.vala"
					_tmp27_[n_lines] = y;
#line 715 "../src/game.vala"
					_tmp28_ = n_lines;
#line 715 "../src/game.vala"
					n_lines = _tmp28_ + 1;
#line 2704 "game.c"
				}
			}
		}
	}
#line 718 "../src/game.vala"
	_tmp29_ = n_lines;
#line 718 "../src/game.vala"
	lines = g_renew (gint, lines, n_lines);
#line 718 "../src/game.vala"
	(_tmp29_ > lines_length1) ? memset (lines + lines_length1, 0, sizeof (gint) * (_tmp29_ - lines_length1)) : NULL;
#line 718 "../src/game.vala"
	lines_length1 = _tmp29_;
#line 718 "../src/game.vala"
	_lines_size_ = _tmp29_;
#line 720 "../src/game.vala"
	line_blocks = NULL;
#line 2721 "game.c"
	{
		gint y = 0;
		gint _tmp30_;
		gint _tmp31_;
#line 721 "../src/game.vala"
		_tmp30_ = game_get_height (self);
#line 721 "../src/game.vala"
		_tmp31_ = _tmp30_;
#line 721 "../src/game.vala"
		y = _tmp31_ - 1;
#line 2732 "game.c"
		{
			gboolean _tmp32_ = FALSE;
#line 721 "../src/game.vala"
			_tmp32_ = TRUE;
#line 721 "../src/game.vala"
			while (TRUE) {
#line 2739 "game.c"
				gboolean explode = FALSE;
#line 721 "../src/game.vala"
				if (!_tmp32_) {
#line 2743 "game.c"
					gint _tmp33_;
#line 721 "../src/game.vala"
					_tmp33_ = y;
#line 721 "../src/game.vala"
					y = _tmp33_ - 1;
#line 2749 "game.c"
				}
#line 721 "../src/game.vala"
				_tmp32_ = FALSE;
#line 721 "../src/game.vala"
				if (!(y >= 0)) {
#line 721 "../src/game.vala"
					break;
#line 2757 "game.c"
				}
#line 723 "../src/game.vala"
				explode = TRUE;
#line 2761 "game.c"
				{
					gint x = 0;
#line 724 "../src/game.vala"
					x = 0;
#line 2766 "game.c"
					{
						gboolean _tmp34_ = FALSE;
#line 724 "../src/game.vala"
						_tmp34_ = TRUE;
#line 724 "../src/game.vala"
						while (TRUE) {
#line 2773 "game.c"
							gint _tmp36_;
							gint _tmp37_;
							Block** _tmp38_;
							gint _tmp38__length1;
							gint _tmp38__length2;
							Block* _tmp39_;
#line 724 "../src/game.vala"
							if (!_tmp34_) {
#line 2782 "game.c"
								gint _tmp35_;
#line 724 "../src/game.vala"
								_tmp35_ = x;
#line 724 "../src/game.vala"
								x = _tmp35_ + 1;
#line 2788 "game.c"
							}
#line 724 "../src/game.vala"
							_tmp34_ = FALSE;
#line 724 "../src/game.vala"
							_tmp36_ = game_get_width (self);
#line 724 "../src/game.vala"
							_tmp37_ = _tmp36_;
#line 724 "../src/game.vala"
							if (!(x < _tmp37_)) {
#line 724 "../src/game.vala"
								break;
#line 2800 "game.c"
							}
#line 726 "../src/game.vala"
							_tmp38_ = self->blocks;
#line 726 "../src/game.vala"
							_tmp38__length1 = self->blocks_length1;
#line 726 "../src/game.vala"
							_tmp38__length2 = self->blocks_length2;
#line 726 "../src/game.vala"
							_tmp39_ = _tmp38_[(x * _tmp38__length2) + y];
#line 726 "../src/game.vala"
							if (_tmp39_ == NULL) {
#line 728 "../src/game.vala"
								explode = FALSE;
#line 729 "../src/game.vala"
								break;
#line 2816 "game.c"
							}
						}
					}
				}
#line 733 "../src/game.vala"
				if (explode) {
#line 2823 "game.c"
					gint _tmp48_;
					{
						gint x = 0;
#line 735 "../src/game.vala"
						x = 0;
#line 2829 "game.c"
						{
							gboolean _tmp40_ = FALSE;
#line 735 "../src/game.vala"
							_tmp40_ = TRUE;
#line 735 "../src/game.vala"
							while (TRUE) {
#line 2836 "game.c"
								gint _tmp42_;
								gint _tmp43_;
								Block** _tmp44_;
								gint _tmp44__length1;
								gint _tmp44__length2;
								Block* _tmp45_;
								Block* _tmp46_;
								Block** _tmp47_;
								gint _tmp47__length1;
								gint _tmp47__length2;
#line 735 "../src/game.vala"
								if (!_tmp40_) {
#line 2849 "game.c"
									gint _tmp41_;
#line 735 "../src/game.vala"
									_tmp41_ = x;
#line 735 "../src/game.vala"
									x = _tmp41_ + 1;
#line 2855 "game.c"
								}
#line 735 "../src/game.vala"
								_tmp40_ = FALSE;
#line 735 "../src/game.vala"
								_tmp42_ = game_get_width (self);
#line 735 "../src/game.vala"
								_tmp43_ = _tmp42_;
#line 735 "../src/game.vala"
								if (!(x < _tmp43_)) {
#line 735 "../src/game.vala"
									break;
#line 2867 "game.c"
								}
#line 737 "../src/game.vala"
								_tmp44_ = self->blocks;
#line 737 "../src/game.vala"
								_tmp44__length1 = self->blocks_length1;
#line 737 "../src/game.vala"
								_tmp44__length2 = self->blocks_length2;
#line 737 "../src/game.vala"
								_tmp45_ = _tmp44_[(x * _tmp44__length2) + y];
#line 737 "../src/game.vala"
								_tmp46_ = _g_object_ref0 (_tmp45_);
#line 737 "../src/game.vala"
								line_blocks = g_list_append (line_blocks, _tmp46_);
#line 738 "../src/game.vala"
								_tmp47_ = self->blocks;
#line 738 "../src/game.vala"
								_tmp47__length1 = self->blocks_length1;
#line 738 "../src/game.vala"
								_tmp47__length2 = self->blocks_length2;
#line 738 "../src/game.vala"
								_g_object_unref0 (_tmp47_[(x * _tmp47__length2) + y]);
#line 738 "../src/game.vala"
								_tmp47_[(x * _tmp47__length2) + y] = NULL;
#line 2891 "game.c"
							}
						}
					}
#line 740 "../src/game.vala"
					_tmp48_ = fall_distance;
#line 740 "../src/game.vala"
					fall_distance = _tmp48_ + 1;
#line 2899 "game.c"
				} else {
#line 742 "../src/game.vala"
					if (fall_distance > 0) {
#line 2903 "game.c"
						{
							gint x = 0;
#line 744 "../src/game.vala"
							x = 0;
#line 2908 "game.c"
							{
								gboolean _tmp49_ = FALSE;
#line 744 "../src/game.vala"
								_tmp49_ = TRUE;
#line 744 "../src/game.vala"
								while (TRUE) {
#line 2915 "game.c"
									gint _tmp51_;
									gint _tmp52_;
									Block* b = NULL;
									Block** _tmp53_;
									gint _tmp53__length1;
									gint _tmp53__length2;
									Block* _tmp54_;
									Block* _tmp55_;
									Block* _tmp56_;
#line 744 "../src/game.vala"
									if (!_tmp49_) {
#line 2927 "game.c"
										gint _tmp50_;
#line 744 "../src/game.vala"
										_tmp50_ = x;
#line 744 "../src/game.vala"
										x = _tmp50_ + 1;
#line 2933 "game.c"
									}
#line 744 "../src/game.vala"
									_tmp49_ = FALSE;
#line 744 "../src/game.vala"
									_tmp51_ = game_get_width (self);
#line 744 "../src/game.vala"
									_tmp52_ = _tmp51_;
#line 744 "../src/game.vala"
									if (!(x < _tmp52_)) {
#line 744 "../src/game.vala"
										break;
#line 2945 "game.c"
									}
#line 746 "../src/game.vala"
									_tmp53_ = self->blocks;
#line 746 "../src/game.vala"
									_tmp53__length1 = self->blocks_length1;
#line 746 "../src/game.vala"
									_tmp53__length2 = self->blocks_length2;
#line 746 "../src/game.vala"
									_tmp54_ = _tmp53_[(x * _tmp53__length2) + y];
#line 746 "../src/game.vala"
									_tmp55_ = _g_object_ref0 (_tmp54_);
#line 746 "../src/game.vala"
									b = _tmp55_;
#line 747 "../src/game.vala"
									_tmp56_ = b;
#line 747 "../src/game.vala"
									if (_tmp56_ != NULL) {
#line 2963 "game.c"
										Block* _tmp57_;
										Block* _tmp58_;
										Block** _tmp59_;
										gint _tmp59__length1;
										gint _tmp59__length2;
										Block* _tmp60_;
										Block* _tmp61_;
										Block* _tmp62_;
										Block* _tmp63_;
										Block** _tmp64_;
										gint _tmp64__length1;
										gint _tmp64__length2;
#line 749 "../src/game.vala"
										_tmp57_ = b;
#line 749 "../src/game.vala"
										_tmp58_ = b;
#line 749 "../src/game.vala"
										_tmp58_->y = _tmp58_->y + fall_distance;
#line 750 "../src/game.vala"
										_tmp59_ = self->blocks;
#line 750 "../src/game.vala"
										_tmp59__length1 = self->blocks_length1;
#line 750 "../src/game.vala"
										_tmp59__length2 = self->blocks_length2;
#line 750 "../src/game.vala"
										_tmp60_ = b;
#line 750 "../src/game.vala"
										_tmp61_ = b;
#line 750 "../src/game.vala"
										_tmp62_ = b;
#line 750 "../src/game.vala"
										_tmp63_ = _g_object_ref0 (_tmp62_);
#line 750 "../src/game.vala"
										_g_object_unref0 (_tmp59_[(_tmp60_->x * _tmp59__length2) + _tmp61_->y]);
#line 750 "../src/game.vala"
										_tmp59_[(_tmp60_->x * _tmp59__length2) + _tmp61_->y] = _tmp63_;
#line 751 "../src/game.vala"
										_tmp64_ = self->blocks;
#line 751 "../src/game.vala"
										_tmp64__length1 = self->blocks_length1;
#line 751 "../src/game.vala"
										_tmp64__length2 = self->blocks_length2;
#line 751 "../src/game.vala"
										_g_object_unref0 (_tmp64_[(x * _tmp64__length2) + y]);
#line 751 "../src/game.vala"
										_tmp64_[(x * _tmp64__length2) + y] = NULL;
#line 3010 "game.c"
									}
#line 744 "../src/game.vala"
									_g_object_unref0 (b);
#line 3014 "game.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 757 "../src/game.vala"
	_tmp65_ = game_get_level (self);
#line 757 "../src/game.vala"
	_tmp66_ = _tmp65_;
#line 757 "../src/game.vala"
	old_level = _tmp66_;
#line 760 "../src/game.vala"
	self->n_lines_destroyed = self->n_lines_destroyed + n_lines;
#line 761 "../src/game.vala"
	switch (n_lines) {
#line 761 "../src/game.vala"
		case 0:
#line 3035 "game.c"
		{
#line 764 "../src/game.vala"
			break;
#line 3039 "game.c"
		}
#line 761 "../src/game.vala"
		case 1:
#line 3043 "game.c"
		{
			gint _tmp67_;
			gint _tmp68_;
#line 766 "../src/game.vala"
			_tmp67_ = game_get_level (self);
#line 766 "../src/game.vala"
			_tmp68_ = _tmp67_;
#line 766 "../src/game.vala"
			self->score = self->score + (40 * _tmp68_);
#line 767 "../src/game.vala"
			break;
#line 3055 "game.c"
		}
#line 761 "../src/game.vala"
		case 2:
#line 3059 "game.c"
		{
			gint _tmp69_;
			gint _tmp70_;
#line 769 "../src/game.vala"
			_tmp69_ = game_get_level (self);
#line 769 "../src/game.vala"
			_tmp70_ = _tmp69_;
#line 769 "../src/game.vala"
			self->score = self->score + (100 * _tmp70_);
#line 770 "../src/game.vala"
			break;
#line 3071 "game.c"
		}
#line 761 "../src/game.vala"
		case 3:
#line 3075 "game.c"
		{
			gint _tmp71_;
			gint _tmp72_;
#line 772 "../src/game.vala"
			_tmp71_ = game_get_level (self);
#line 772 "../src/game.vala"
			_tmp72_ = _tmp71_;
#line 772 "../src/game.vala"
			self->score = self->score + (300 * _tmp72_);
#line 773 "../src/game.vala"
			break;
#line 3087 "game.c"
		}
#line 761 "../src/game.vala"
		case 4:
#line 3091 "game.c"
		{
			gint _tmp73_;
			gint _tmp74_;
#line 775 "../src/game.vala"
			_tmp73_ = game_get_level (self);
#line 775 "../src/game.vala"
			_tmp74_ = _tmp73_;
#line 775 "../src/game.vala"
			self->score = self->score + (1200 * _tmp74_);
#line 776 "../src/game.vala"
			break;
#line 3103 "game.c"
		}
		default:
#line 761 "../src/game.vala"
		break;
#line 3108 "game.c"
	}
#line 779 "../src/game.vala"
	if (base_line_destroyed) {
#line 3112 "game.c"
		gint _tmp75_;
		gint _tmp76_;
#line 780 "../src/game.vala"
		_tmp75_ = game_get_level (self);
#line 780 "../src/game.vala"
		_tmp76_ = _tmp75_;
#line 780 "../src/game.vala"
		self->score = self->score + (10000 * _tmp76_);
#line 3121 "game.c"
	}
#line 783 "../src/game.vala"
	_tmp77_ = game_get_level (self);
#line 783 "../src/game.vala"
	_tmp78_ = _tmp77_;
#line 783 "../src/game.vala"
	if (_tmp78_ != old_level) {
#line 784 "../src/game.vala"
		game_setup_drop_timer (self);
#line 3131 "game.c"
	}
#line 786 "../src/game.vala"
	_tmp79_ = lines;
#line 786 "../src/game.vala"
	_tmp79__length1 = lines_length1;
#line 786 "../src/game.vala"
	_tmp80_ = line_blocks;
#line 786 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_SHAPE_LANDED_SIGNAL], 0, _tmp79_, (gint) _tmp79__length1, _tmp80_);
#line 787 "../src/game.vala"
	_g_object_unref0 (self->shape);
#line 787 "../src/game.vala"
	self->shape = NULL;
#line 684 "../src/game.vala"
	(line_blocks == NULL) ? NULL : (line_blocks = (_g_list_free__g_object_unref0_ (line_blocks), NULL));
#line 684 "../src/game.vala"
	lines = (g_free (lines), NULL);
#line 3149 "game.c"
}

static gboolean
game_move_shape (Game* self,
                 gint x_step,
                 gint y_step,
                 gint r_step)
{
	Shape* _tmp0_;
	gboolean can_move = FALSE;
	Shape* _tmp1_;
	GList* _tmp2_;
	gboolean result;
#line 790 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 792 "../src/game.vala"
	_tmp0_ = self->shape;
#line 792 "../src/game.vala"
	if (_tmp0_ == NULL) {
#line 793 "../src/game.vala"
		result = FALSE;
#line 793 "../src/game.vala"
		return result;
#line 3173 "game.c"
	}
#line 796 "../src/game.vala"
	game_rotate_shape (self, r_step);
#line 797 "../src/game.vala"
	can_move = TRUE;
#line 798 "../src/game.vala"
	_tmp1_ = self->shape;
#line 798 "../src/game.vala"
	_tmp2_ = _tmp1_->blocks;
#line 3183 "game.c"
	{
		GList* b_collection = NULL;
		GList* b_it = NULL;
#line 798 "../src/game.vala"
		b_collection = _tmp2_;
#line 798 "../src/game.vala"
		for (b_it = b_collection; b_it != NULL; b_it = b_it->next) {
#line 3191 "game.c"
			Block* _tmp3_;
			Block* b = NULL;
#line 798 "../src/game.vala"
			_tmp3_ = _g_object_ref0 ((Block*) b_it->data);
#line 798 "../src/game.vala"
			b = _tmp3_;
#line 3198 "game.c"
			{
				gint x = 0;
				Shape* _tmp4_;
				Block* _tmp5_;
				gint y = 0;
				Shape* _tmp6_;
				Block* _tmp7_;
				gboolean _tmp8_ = FALSE;
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
#line 800 "../src/game.vala"
				_tmp4_ = self->shape;
#line 800 "../src/game.vala"
				_tmp5_ = b;
#line 800 "../src/game.vala"
				x = (_tmp4_->x + x_step) + _tmp5_->x;
#line 801 "../src/game.vala"
				_tmp6_ = self->shape;
#line 801 "../src/game.vala"
				_tmp7_ = b;
#line 801 "../src/game.vala"
				y = (_tmp6_->y + y_step) + _tmp7_->y;
#line 802 "../src/game.vala"
				if (x < 0) {
#line 802 "../src/game.vala"
					_tmp10_ = TRUE;
#line 3225 "game.c"
				} else {
					gint _tmp11_;
					gint _tmp12_;
#line 802 "../src/game.vala"
					_tmp11_ = game_get_width (self);
#line 802 "../src/game.vala"
					_tmp12_ = _tmp11_;
#line 802 "../src/game.vala"
					_tmp10_ = x >= _tmp12_;
#line 3235 "game.c"
				}
#line 802 "../src/game.vala"
				if (_tmp10_) {
#line 802 "../src/game.vala"
					_tmp9_ = TRUE;
#line 3241 "game.c"
				} else {
					gint _tmp13_;
					gint _tmp14_;
#line 802 "../src/game.vala"
					_tmp13_ = game_get_height (self);
#line 802 "../src/game.vala"
					_tmp14_ = _tmp13_;
#line 802 "../src/game.vala"
					_tmp9_ = y >= _tmp14_;
#line 3251 "game.c"
				}
#line 802 "../src/game.vala"
				if (_tmp9_) {
#line 802 "../src/game.vala"
					_tmp8_ = TRUE;
#line 3257 "game.c"
				} else {
					Block** _tmp15_;
					gint _tmp15__length1;
					gint _tmp15__length2;
					Block* _tmp16_;
#line 802 "../src/game.vala"
					_tmp15_ = self->blocks;
#line 802 "../src/game.vala"
					_tmp15__length1 = self->blocks_length1;
#line 802 "../src/game.vala"
					_tmp15__length2 = self->blocks_length2;
#line 802 "../src/game.vala"
					_tmp16_ = _tmp15_[(x * _tmp15__length2) + y];
#line 802 "../src/game.vala"
					_tmp8_ = _tmp16_ != NULL;
#line 3273 "game.c"
				}
#line 802 "../src/game.vala"
				if (_tmp8_) {
#line 804 "../src/game.vala"
					can_move = FALSE;
#line 805 "../src/game.vala"
					_g_object_unref0 (b);
#line 805 "../src/game.vala"
					break;
#line 3283 "game.c"
				}
#line 798 "../src/game.vala"
				_g_object_unref0 (b);
#line 3287 "game.c"
			}
		}
	}
#line 810 "../src/game.vala"
	if (can_move) {
#line 3293 "game.c"
		Shape* _tmp17_;
		Shape* _tmp18_;
		Shape* _tmp19_;
		Shape* _tmp20_;
#line 812 "../src/game.vala"
		_tmp17_ = self->shape;
#line 812 "../src/game.vala"
		_tmp18_ = self->shape;
#line 812 "../src/game.vala"
		_tmp18_->x = _tmp18_->x + x_step;
#line 813 "../src/game.vala"
		_tmp19_ = self->shape;
#line 813 "../src/game.vala"
		_tmp20_ = self->shape;
#line 813 "../src/game.vala"
		_tmp20_->y = _tmp20_->y + y_step;
#line 815 "../src/game.vala"
		if (x_step != 0) {
#line 816 "../src/game.vala"
			g_signal_emit (self, game_signals[GAME_SHAPE_MOVED_SIGNAL], 0);
#line 3314 "game.c"
		} else {
#line 817 "../src/game.vala"
			if (y_step > 0) {
#line 818 "../src/game.vala"
				g_signal_emit (self, game_signals[GAME_SHAPE_DROPPED_SIGNAL], 0);
#line 3320 "game.c"
			} else {
#line 820 "../src/game.vala"
				g_signal_emit (self, game_signals[GAME_SHAPE_ROTATED_SIGNAL], 0);
#line 3324 "game.c"
			}
		}
	} else {
#line 823 "../src/game.vala"
		game_rotate_shape (self, -r_step);
#line 3330 "game.c"
	}
#line 825 "../src/game.vala"
	result = can_move;
#line 825 "../src/game.vala"
	return result;
#line 3336 "game.c"
}

static void
game_rotate_shape (Game* self,
                   gint r_step)
{
	gint r = 0;
	Shape* _tmp0_;
	Shape* _tmp1_;
	Shape* _tmp2_;
	GList* b = NULL;
	Shape* _tmp3_;
	GList* _tmp4_;
	gint offset = 0;
	Shape* _tmp5_;
#line 828 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 830 "../src/game.vala"
	_tmp0_ = self->shape;
#line 830 "../src/game.vala"
	r = _tmp0_->rotation + r_step;
#line 831 "../src/game.vala"
	if (r < 0) {
#line 832 "../src/game.vala"
		r += 4;
#line 3362 "game.c"
	}
#line 833 "../src/game.vala"
	if (r >= 4) {
#line 834 "../src/game.vala"
		r -= 4;
#line 3368 "game.c"
	}
#line 836 "../src/game.vala"
	_tmp1_ = self->shape;
#line 836 "../src/game.vala"
	if (r == _tmp1_->rotation) {
#line 837 "../src/game.vala"
		return;
#line 3376 "game.c"
	}
#line 838 "../src/game.vala"
	_tmp2_ = self->shape;
#line 838 "../src/game.vala"
	_tmp2_->rotation = r;
#line 841 "../src/game.vala"
	_tmp3_ = self->shape;
#line 841 "../src/game.vala"
	_tmp4_ = _tmp3_->blocks;
#line 841 "../src/game.vala"
	b = _tmp4_;
#line 842 "../src/game.vala"
	_tmp5_ = self->shape;
#line 842 "../src/game.vala"
	offset = (_tmp5_->type * 64) + (r * 16);
#line 3392 "game.c"
	{
		gint x = 0;
#line 843 "../src/game.vala"
		x = 0;
#line 3397 "game.c"
		{
			gboolean _tmp6_ = FALSE;
#line 843 "../src/game.vala"
			_tmp6_ = TRUE;
#line 843 "../src/game.vala"
			while (TRUE) {
#line 843 "../src/game.vala"
				if (!_tmp6_) {
#line 3406 "game.c"
					gint _tmp7_;
#line 843 "../src/game.vala"
					_tmp7_ = x;
#line 843 "../src/game.vala"
					x = _tmp7_ + 1;
#line 3412 "game.c"
				}
#line 843 "../src/game.vala"
				_tmp6_ = FALSE;
#line 843 "../src/game.vala"
				if (!(x < 4)) {
#line 843 "../src/game.vala"
					break;
#line 3420 "game.c"
				}
				{
					gint y = 0;
#line 845 "../src/game.vala"
					y = 0;
#line 3426 "game.c"
					{
						gboolean _tmp8_ = FALSE;
#line 845 "../src/game.vala"
						_tmp8_ = TRUE;
#line 845 "../src/game.vala"
						while (TRUE) {
#line 3433 "game.c"
							gint _tmp10_;
#line 845 "../src/game.vala"
							if (!_tmp8_) {
#line 3437 "game.c"
								gint _tmp9_;
#line 845 "../src/game.vala"
								_tmp9_ = y;
#line 845 "../src/game.vala"
								y = _tmp9_ + 1;
#line 3443 "game.c"
							}
#line 845 "../src/game.vala"
							_tmp8_ = FALSE;
#line 845 "../src/game.vala"
							if (!(y < 4)) {
#line 845 "../src/game.vala"
								break;
#line 3451 "game.c"
							}
#line 847 "../src/game.vala"
							_tmp10_ = block_table[(offset + (y * 4)) + x];
#line 847 "../src/game.vala"
							if (_tmp10_ != 0) {
#line 3457 "game.c"
								GList* _tmp11_;
								gconstpointer _tmp12_;
								GList* _tmp13_;
								gconstpointer _tmp14_;
								GList* _tmp15_;
								GList* _tmp16_;
#line 849 "../src/game.vala"
								_tmp11_ = b;
#line 849 "../src/game.vala"
								_tmp12_ = _tmp11_->data;
#line 849 "../src/game.vala"
								((Block*) _tmp12_)->x = x;
#line 850 "../src/game.vala"
								_tmp13_ = b;
#line 850 "../src/game.vala"
								_tmp14_ = _tmp13_->data;
#line 850 "../src/game.vala"
								((Block*) _tmp14_)->y = y;
#line 851 "../src/game.vala"
								_tmp15_ = b;
#line 851 "../src/game.vala"
								_tmp16_ = _tmp15_->next;
#line 851 "../src/game.vala"
								b = _tmp16_;
#line 3482 "game.c"
							}
						}
					}
				}
			}
		}
	}
}

gint
game_get_width (Game* self)
{
	gint result;
	Block** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
#line 230 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 230 "../src/game.vala"
	_tmp0_ = self->blocks;
#line 230 "../src/game.vala"
	_tmp0__length1 = self->blocks_length1;
#line 230 "../src/game.vala"
	_tmp0__length2 = self->blocks_length2;
#line 230 "../src/game.vala"
	_tmp1_ = _tmp0__length1;
#line 230 "../src/game.vala"
	result = _tmp1_;
#line 230 "../src/game.vala"
	return result;
#line 3514 "game.c"
}

gint
game_get_height (Game* self)
{
	gint result;
	Block** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
#line 231 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 231 "../src/game.vala"
	_tmp0_ = self->blocks;
#line 231 "../src/game.vala"
	_tmp0__length1 = self->blocks_length1;
#line 231 "../src/game.vala"
	_tmp0__length2 = self->blocks_length2;
#line 231 "../src/game.vala"
	_tmp1_ = _tmp0__length2;
#line 231 "../src/game.vala"
	result = _tmp1_;
#line 231 "../src/game.vala"
	return result;
#line 3539 "game.c"
}

gint
game_get_level (Game* self)
{
	gint result;
#line 246 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 246 "../src/game.vala"
	result = self->priv->starting_level + (self->n_lines_destroyed / 10);
#line 246 "../src/game.vala"
	return result;
#line 3552 "game.c"
}

gboolean
game_get_paused (Game* self)
{
	gboolean result;
#line 267 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 267 "../src/game.vala"
	result = self->priv->_paused;
#line 267 "../src/game.vala"
	return result;
#line 3565 "game.c"
}

void
game_set_paused (Game* self,
                 gboolean value)
{
	gboolean _tmp0_ = FALSE;
#line 268 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/game.vala"
	self->priv->_paused = value;
#line 271 "../src/game.vala"
	if (self->priv->has_started) {
#line 271 "../src/game.vala"
		_tmp0_ = !self->game_over;
#line 3581 "game.c"
	} else {
#line 271 "../src/game.vala"
		_tmp0_ = FALSE;
#line 3585 "game.c"
	}
#line 271 "../src/game.vala"
	if (_tmp0_) {
#line 272 "../src/game.vala"
		game_setup_drop_timer (self);
#line 3591 "game.c"
	}
#line 273 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_PAUSE_CHANGED_SIGNAL], 0);
#line 268 "../src/game.vala"
	g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_PAUSED_PROPERTY]);
#line 3597 "game.c"
}

gint
game_get_shadow_y (Game* self)
{
	gint result;
	Shape* _tmp0_;
	gint d = 0;
	Game* g = NULL;
	Game* _tmp1_;
	Shape* _tmp4_;
#line 280 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 282 "../src/game.vala"
	_tmp0_ = self->shape;
#line 282 "../src/game.vala"
	if (_tmp0_ == NULL) {
#line 283 "../src/game.vala"
		result = 0;
#line 283 "../src/game.vala"
		return result;
#line 3619 "game.c"
	}
#line 285 "../src/game.vala"
	d = 0;
#line 286 "../src/game.vala"
	_tmp1_ = game_copy (self);
#line 286 "../src/game.vala"
	g = _tmp1_;
#line 287 "../src/game.vala"
	while (TRUE) {
#line 3629 "game.c"
		Game* _tmp2_;
		gint _tmp3_;
#line 287 "../src/game.vala"
		_tmp2_ = g;
#line 287 "../src/game.vala"
		if (!game_move_shape (_tmp2_, 0, 1, 0)) {
#line 287 "../src/game.vala"
			break;
#line 3638 "game.c"
		}
#line 288 "../src/game.vala"
		_tmp3_ = d;
#line 288 "../src/game.vala"
		d = _tmp3_ + 1;
#line 3644 "game.c"
	}
#line 290 "../src/game.vala"
	_tmp4_ = self->shape;
#line 290 "../src/game.vala"
	result = _tmp4_->y + d;
#line 290 "../src/game.vala"
	_g_object_unref0 (g);
#line 290 "../src/game.vala"
	return result;
#line 3654 "game.c"
}

static void
g_cclosure_user_marshal_VOID__POINTER_INT_POINTER (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__POINTER_INT_POINTER) (gpointer data1, gpointer arg_1, gint arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__POINTER_INT_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 219 "../src/game.vala"
	g_return_if_fail (n_param_values == 4);
#line 219 "../src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 219 "../src/game.vala"
		data1 = closure->data;
#line 219 "../src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 3679 "game.c"
	} else {
#line 219 "../src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 219 "../src/game.vala"
		data2 = closure->data;
#line 3685 "game.c"
	}
#line 219 "../src/game.vala"
	callback = (GMarshalFunc_VOID__POINTER_INT_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 219 "../src/game.vala"
	callback (data1, g_value_get_pointer (param_values + 1), g_value_get_int (param_values + 2), g_value_get_pointer (param_values + 3), data2);
#line 3691 "game.c"
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
#line 219 "../src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 219 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
#line 219 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 219 "../src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 219 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 219 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_WIDTH_PROPERTY, game_properties[GAME_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 219 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HEIGHT_PROPERTY, game_properties[GAME_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 219 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_LEVEL_PROPERTY, game_properties[GAME_LEVEL_PROPERTY] = g_param_spec_int ("level", "level", "level", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 219 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_PAUSED_PROPERTY, game_properties[GAME_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 219 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SHADOW_Y_PROPERTY, game_properties[GAME_SHADOW_Y_PROPERTY] = g_param_spec_int ("shadow-y", "shadow-y", "shadow-y", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 219 "../src/game.vala"
	game_signals[GAME_STARTED_SIGNAL] = g_signal_new ("started", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 219 "../src/game.vala"
	game_signals[GAME_SHAPE_ADDED_SIGNAL] = g_signal_new ("shape-added", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 219 "../src/game.vala"
	game_signals[GAME_SHAPE_MOVED_SIGNAL] = g_signal_new ("shape-moved", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 219 "../src/game.vala"
	game_signals[GAME_SHAPE_DROPPED_SIGNAL] = g_signal_new ("shape-dropped", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 219 "../src/game.vala"
	game_signals[GAME_SHAPE_ROTATED_SIGNAL] = g_signal_new ("shape-rotated", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 219 "../src/game.vala"
	game_signals[GAME_SHAPE_LANDED_SIGNAL] = g_signal_new ("shape-landed", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__POINTER_INT_POINTER, G_TYPE_NONE, 3, G_TYPE_POINTER, G_TYPE_INT, G_TYPE_POINTER);
#line 219 "../src/game.vala"
	game_signals[GAME_PAUSE_CHANGED_SIGNAL] = g_signal_new ("pause-changed", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 219 "../src/game.vala"
	game_signals[GAME_COMPLETE_SIGNAL] = g_signal_new ("complete", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3734 "game.c"
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
#line 219 "../src/game.vala"
	self->priv = game_get_instance_private (self);
#line 222 "../src/game.vala"
	self->shape = NULL;
#line 225 "../src/game.vala"
	self->next_shape = NULL;
#line 234 "../src/game.vala"
	self->n_lines_destroyed = 0;
#line 237 "../src/game.vala"
	self->score = 0;
#line 240 "../src/game.vala"
	self->priv->starting_level = 1;
#line 243 "../src/game.vala"
	self->priv->pick_difficult_blocks = FALSE;
#line 249 "../src/game.vala"
	self->priv->fast_move_direction = 0;
#line 252 "../src/game.vala"
	self->priv->fast_move_timeout = (guint) 0;
#line 255 "../src/game.vala"
	self->priv->fast_forward = FALSE;
#line 258 "../src/game.vala"
	self->priv->drop_timeout = (guint) 0;
#line 261 "../src/game.vala"
	self->priv->has_started = FALSE;
#line 264 "../src/game.vala"
	self->priv->_paused = FALSE;
#line 294 "../src/game.vala"
	self->game_over = FALSE;
#line 3769 "game.c"
}

static void
game_finalize (GObject * obj)
{
	Game * self;
#line 219 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 222 "../src/game.vala"
	_g_object_unref0 (self->shape);
#line 225 "../src/game.vala"
	_g_object_unref0 (self->next_shape);
#line 228 "../src/game.vala"
	self->blocks = (_vala_array_free (self->blocks, self->blocks_length1 * self->blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 219 "../src/game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 3786 "game.c"
}

static GType
game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
	GType game_type_id;
	game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
	Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
	return game_type_id;
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__once = 0;
	if (g_once_init_enter (&game_type_id__once)) {
		GType game_type_id;
		game_type_id = game_get_type_once ();
		g_once_init_leave (&game_type_id__once, game_type_id);
	}
	return game_type_id__once;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 219 "../src/game.vala"
	switch (property_id) {
#line 219 "../src/game.vala"
		case GAME_WIDTH_PROPERTY:
#line 219 "../src/game.vala"
		g_value_set_int (value, game_get_width (self));
#line 219 "../src/game.vala"
		break;
#line 219 "../src/game.vala"
		case GAME_HEIGHT_PROPERTY:
#line 219 "../src/game.vala"
		g_value_set_int (value, game_get_height (self));
#line 219 "../src/game.vala"
		break;
#line 219 "../src/game.vala"
		case GAME_LEVEL_PROPERTY:
#line 219 "../src/game.vala"
		g_value_set_int (value, game_get_level (self));
#line 219 "../src/game.vala"
		break;
#line 219 "../src/game.vala"
		case GAME_PAUSED_PROPERTY:
#line 219 "../src/game.vala"
		g_value_set_boolean (value, game_get_paused (self));
#line 219 "../src/game.vala"
		break;
#line 219 "../src/game.vala"
		case GAME_SHADOW_Y_PROPERTY:
#line 219 "../src/game.vala"
		g_value_set_int (value, game_get_shadow_y (self));
#line 219 "../src/game.vala"
		break;
#line 3851 "game.c"
		default:
#line 219 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 219 "../src/game.vala"
		break;
#line 3857 "game.c"
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 219 "../src/game.vala"
	switch (property_id) {
#line 219 "../src/game.vala"
		case GAME_PAUSED_PROPERTY:
#line 219 "../src/game.vala"
		game_set_paused (self, g_value_get_boolean (value));
#line 219 "../src/game.vala"
		break;
#line 3877 "game.c"
		default:
#line 219 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 219 "../src/game.vala"
		break;
#line 3883 "game.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

